
#include <glib.h>
#include <glib-object.h>
#include <panel-applet.h>
#include <libgnomenu.h>
#include <libnotify/notify.h>
#include <glib/gi18n-lib.h>
#include <libbonoboui.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <libwnck/libwnck.h>
#include <gconf/gconf-client.h>
#include <configmake.h>
#include <glib/gstdio.h>
#include <libgnome/libgnome.h>


#define TYPE_APPLET (applet_get_type ())
#define APPLET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_APPLET, GlobalMenuPanelApplet))
#define APPLET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_APPLET, GlobalMenuPanelAppletClass))
#define IS_APPLET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_APPLET))
#define IS_APPLET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_APPLET))
#define APPLET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_APPLET, GlobalMenuPanelAppletClass))

typedef struct _GlobalMenuPanelApplet GlobalMenuPanelApplet;
typedef struct _GlobalMenuPanelAppletClass GlobalMenuPanelAppletClass;
typedef struct _GlobalMenuPanelAppletPrivate GlobalMenuPanelAppletPrivate;

#define TYPE_SWITCHER (switcher_get_type ())
#define SWITCHER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SWITCHER, Switcher))
#define SWITCHER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SWITCHER, SwitcherClass))
#define IS_SWITCHER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SWITCHER))
#define IS_SWITCHER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SWITCHER))
#define SWITCHER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SWITCHER, SwitcherClass))

typedef struct _Switcher Switcher;
typedef struct _SwitcherClass SwitcherClass;

#define TYPE_GCONF_DIALOG (gconf_dialog_get_type ())
#define GCONF_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GCONF_DIALOG, GConfDialog))
#define GCONF_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GCONF_DIALOG, GConfDialogClass))
#define IS_GCONF_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GCONF_DIALOG))
#define IS_GCONF_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GCONF_DIALOG))
#define GCONF_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GCONF_DIALOG, GConfDialogClass))

typedef struct _GConfDialog GConfDialog;
typedef struct _GConfDialogClass GConfDialogClass;

struct _GlobalMenuPanelApplet {
	PanelApplet parent_instance;
	GlobalMenuPanelAppletPrivate * priv;
	gboolean disable_module_check;
};

struct _GlobalMenuPanelAppletClass {
	PanelAppletClass parent_class;
};

struct _GlobalMenuPanelAppletPrivate {
	GnomenuMonitor* monitor;
	GnomenuMenuBarBox* menubars;
	gboolean disposed;
	GnomenuGlobalMenu* main_menubar;
	Switcher* switcher;
	NotifyNotification* notify_no_plugin;
	gboolean initialized;
	gboolean _has_handle;
};



GType applet_get_type (void);
GType switcher_get_type (void);
#define APPLET_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_APPLET, GlobalMenuPanelAppletPrivate))
enum  {
	APPLET_DUMMY_PROPERTY,
	APPLET_HAS_HANDLE
};
static char** applet_subs;
static gint applet_subs_length1;
static char** applet_subs = NULL;
static gint applet_subs_length1 = 0;
static gint applet_subs_size = 0;
Switcher* switcher_new (void);
Switcher* switcher_construct (GType object_type);
#define APPLET_IID "OAFIID:GlobalMenu_PanelApplet"
#define APPLET_applet_menu_xml_template "\n<popup name=\"button3\">\n\t<menuitem name=\"Preferences\" \n\t\tverb=\"Preferences\" \n\t\t_label=\"@Preferences@\"\n\t\tpixtype=\"stock\" \n\t\tpixname=\"gtk-preferences\"/>\n\t<menuitem name=\"Help\" \n\t\tverb=\"Help\" \n\t\t_label=\"@Help@\"\n\t\tpixtype=\"stock\" \n\t\tpixname=\"gtk-help\"/>\n\t<menuitem name=\"About\" \n\t\tverb=\"About\" \n\t\t_label=\"@About@\"\n\t\tpixtype=\"stock\" \n\t\tpixname=\"gtk-about\"/>\n</popup>\n\t"
#define APPLET_APPLET_NAME _ ("globalmenu-panel-applet")
#define APPLET_APPLET_ICON "globalmenu"
#define APPLET_GCONF_SCHEMA_DIR "/schemas/apps/globalmenu-panel-applet/prefs"
static void applet_applet_menu_clicked (BonoboUIComponent* component, GlobalMenuPanelApplet* self, const char* cname);
GlobalMenuPanelApplet* applet_new (void);
GlobalMenuPanelApplet* applet_construct (GType object_type);
GlobalMenuPanelApplet* applet_new (void);
static void applet_real_dispose (GObject* base);
static void applet_check_module (GlobalMenuPanelApplet* self);
static void _applet_check_module_g_object_notify (GtkSettings* _sender, GParamSpec* pspec, gpointer self);
static void applet_real_screen_changed (GtkWidget* base, GdkScreen* previous_screen);
void switcher_set_current_window (Switcher* self, WnckWindow* value);
static void applet_on_window_changed (GlobalMenuPanelApplet* self, GnomenuMonitor* monitor, gulong prev_xid);
static void applet_real_change_background (PanelApplet* base, PanelAppletBackgroundType type, const GdkColor* color, GdkPixmap* pixmap);
static void applet_update_size (GlobalMenuPanelApplet* self);
static void applet_real_change_orient (PanelApplet* base, PanelAppletOrient orient);
static void applet_real_change_size (PanelApplet* base, guint size);
static void applet_get_prefs (GlobalMenuPanelApplet* self);
static void _lambda4_ (const char* key, void* value, GlobalMenuPanelApplet* self);
static void __lambda4__gconf_client_value_changed (GConfClient* _sender, const char* key, void* value, gpointer self);
char* template_replace (const char* template, char** subs, int subs_length1);
void applet_init (GlobalMenuPanelApplet* self);
void switcher_set_max_size (Switcher* self, gint value);
void switcher_set_show_icon (Switcher* self, gboolean value);
void switcher_set_show_label (Switcher* self, gboolean value);
void switcher_set_show_window_actions (Switcher* self, gboolean value);
void switcher_set_show_window_list (Switcher* self, gboolean value);
void applet_set_has_handle (GlobalMenuPanelApplet* self, gboolean value);
static void applet_show_about (GlobalMenuPanelApplet* self);
static void applet_show_preferences (GlobalMenuPanelApplet* self);
static void applet_show_help (GlobalMenuPanelApplet* self);
GConfDialog* gconf_dialog_new (const char* dialog_title);
GConfDialog* gconf_dialog_construct (GType object_type, const char* dialog_title);
GType gconf_dialog_get_type (void);
void gconf_dialog_add_key_group (GConfDialog* self, const char* group_name, char** keys, int keys_length1);
static gboolean applet_real_button_press_event (GtkWidget* base, const GdkEventButton* event);
gboolean applet_get_has_handle (GlobalMenuPanelApplet* self);
static void applet_real_size_request (GtkWidget* base, GtkRequisition* req);
static gboolean _lambda5_ (GtkWidget* widget, const GdkEventButton* event, GlobalMenuPanelApplet* self);
static gboolean __lambda5__gtk_widget_button_press_event (GtkWidget* _sender, const GdkEventButton* event, gpointer self);
static void applet_setup_popup_menu (GlobalMenuPanelApplet* self, GtkWidget* widget);
static void _applet_on_window_changed_gnomenu_monitor_window_changed (GnomenuMonitor* _sender, gulong old_xid, gpointer self);
static GObject * applet_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static gpointer applet_parent_class = NULL;
static void applet_finalize (GObject* obj);
static void applet_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void applet_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

static const BonoboUIVerb APPLET_verbs[] = {{"About", (BonoboUIVerbFn) applet_applet_menu_clicked, NULL}, {"Help", (BonoboUIVerbFn) applet_applet_menu_clicked, NULL}, {"Preferences", (BonoboUIVerbFn) applet_applet_menu_clicked, NULL}, {NULL, NULL, NULL}};


GlobalMenuPanelApplet* applet_construct (GType object_type) {
	GlobalMenuPanelApplet * self;
	self = g_object_newv (object_type, 0, NULL);
	return self;
}


GlobalMenuPanelApplet* applet_new (void) {
	return applet_construct (TYPE_APPLET);
}


static void applet_real_dispose (GObject* base) {
	GlobalMenuPanelApplet * self;
	self = (GlobalMenuPanelApplet*) base;
	if (!self->priv->disposed) {
		self->priv->disposed = TRUE;
		panel_applet_set_background_widget ((PanelApplet*) self, NULL);
	}
	G_OBJECT_CLASS (applet_parent_class)->dispose ((GObject*) PANEL_APPLET (self));
}


static void _applet_check_module_g_object_notify (GtkSettings* _sender, GParamSpec* pspec, gpointer self) {
	applet_check_module (self);
}


static void applet_real_screen_changed (GtkWidget* base, GdkScreen* previous_screen) {
	GlobalMenuPanelApplet * self;
	GdkScreen* _tmp0_;
	GdkScreen* screen;
	self = (GlobalMenuPanelApplet*) base;
	_tmp0_ = NULL;
	screen = (_tmp0_ = gtk_widget_get_screen ((GtkWidget*) self), (_tmp0_ == NULL) ? NULL : g_object_ref (_tmp0_));
	if (previous_screen != NULL) {
		GtkSettings* _tmp1_;
		GtkSettings* old_settings;
		guint _tmp2_;
		_tmp1_ = NULL;
		old_settings = (_tmp1_ = gtk_settings_get_for_screen (previous_screen), (_tmp1_ == NULL) ? NULL : g_object_ref (_tmp1_));
		/* Work around an old vala bug on disconnecting signals
		 * perhaps already fixed but ...*/
		g_signal_handlers_disconnect_matched ((GObject*) old_settings, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, (g_signal_parse_name ("notify", G_TYPE_OBJECT, &_tmp2_, NULL, FALSE), _tmp2_), 0, NULL, (GCallback) _applet_check_module_g_object_notify, self);
		(old_settings == NULL) ? NULL : (old_settings = (g_object_unref (old_settings), NULL));
	}
	if (screen != NULL) {
		applet_check_module (self);
		gnomenu_monitor_set_screen (self->priv->monitor, screen);
		g_signal_connect_object ((GObject*) gtk_widget_get_settings ((GtkWidget*) self), "notify::gtk-modules", (GCallback) _applet_check_module_g_object_notify, self, 0);
	}
	(screen == NULL) ? NULL : (screen = (g_object_unref (screen), NULL));
}


static void applet_on_window_changed (GlobalMenuPanelApplet* self, GnomenuMonitor* monitor, gulong prev_xid) {
	gulong xid;
	WnckWindow* _tmp0_;
	WnckWindow* window;
	g_return_if_fail (self != NULL);
	g_return_if_fail (monitor != NULL);
	xid = gnomenu_monitor_get_current_xid (monitor);
	_tmp0_ = NULL;
	window = (_tmp0_ = wnck_window_get (xid), (_tmp0_ == NULL) ? NULL : g_object_ref (_tmp0_));
	if (WNCK_IS_WINDOW (window)) {
		switcher_set_current_window (self->priv->switcher, window);
	}
	gnomenu_global_menu_switch_to (self->priv->main_menubar, xid);
	(window == NULL) ? NULL : (window = (g_object_unref (window), NULL));
}


static void applet_real_change_background (PanelApplet* base, PanelAppletBackgroundType type, const GdkColor* color, GdkPixmap* pixmap) {
	GlobalMenuPanelApplet * self;
	GnomenuBackground* bg;
	self = (GlobalMenuPanelApplet*) base;
	bg = gnomenu_background_new ();
	switch (type) {
		case PANEL_NO_BACKGROUND:
		{
			break;
		}
		case PANEL_COLOR_BACKGROUND:
		{
			bg->type = GNOMENU_BACKGROUND_TYPE_COLOR;
			bg->color = *color;
			break;
		}
		case PANEL_PIXMAP_BACKGROUND:
		{
			GdkPixmap* _tmp1_;
			GdkPixmap* _tmp0_;
			bg->type = GNOMENU_BACKGROUND_TYPE_PIXMAP;
			_tmp1_ = NULL;
			_tmp0_ = NULL;
			bg->pixmap = (_tmp1_ = (_tmp0_ = pixmap, (_tmp0_ == NULL) ? NULL : g_object_ref (_tmp0_)), (bg->pixmap == NULL) ? NULL : (bg->pixmap = (g_object_unref (bg->pixmap), NULL)), _tmp1_);
			break;
		}
	}
	gnomenu_menu_bar_box_set_background (self->priv->menubars, bg);
	(bg == NULL) ? NULL : (bg = (gnomenu_background_unref (bg), NULL));
}


static void applet_real_change_orient (PanelApplet* base, PanelAppletOrient orient) {
	GlobalMenuPanelApplet * self;
	self = (GlobalMenuPanelApplet*) base;
	applet_update_size (self);
}


static void applet_real_change_size (PanelApplet* base, guint size) {
	GlobalMenuPanelApplet * self;
	self = (GlobalMenuPanelApplet*) base;
	applet_update_size (self);
}


static void applet_update_size (GlobalMenuPanelApplet* self) {
	g_return_if_fail (self != NULL);
	switch (panel_applet_get_orient ((PanelApplet*) self)) {
		case PANEL_APPLET_ORIENT_UP:
		{
			gnomenu_menu_bar_box_set_gravity (self->priv->menubars, GNOMENU_GRAVITY_DOWN);
			gnomenu_menu_bar_box_set_pack_direction (self->priv->menubars, GTK_PACK_DIRECTION_LTR);
			gnomenu_menu_bar_box_set_child_pack_direction (self->priv->menubars, GTK_PACK_DIRECTION_LTR);
			gtk_widget_set_size_request ((GtkWidget*) self->priv->menubars, (gint) panel_applet_get_size ((PanelApplet*) self), -1);
			break;
		}
		case PANEL_APPLET_ORIENT_DOWN:
		{
			gnomenu_menu_bar_box_set_gravity (self->priv->menubars, GNOMENU_GRAVITY_DOWN);
			gnomenu_menu_bar_box_set_pack_direction (self->priv->menubars, GTK_PACK_DIRECTION_LTR);
			gnomenu_menu_bar_box_set_child_pack_direction (self->priv->menubars, GTK_PACK_DIRECTION_LTR);
			gtk_widget_set_size_request ((GtkWidget*) self->priv->menubars, (gint) panel_applet_get_size ((PanelApplet*) self), -1);
			break;
		}
		case PANEL_APPLET_ORIENT_LEFT:
		{
			gnomenu_menu_bar_box_set_gravity (self->priv->menubars, GNOMENU_GRAVITY_LEFT);
			gnomenu_menu_bar_box_set_pack_direction (self->priv->menubars, GTK_PACK_DIRECTION_TTB);
			gnomenu_menu_bar_box_set_child_pack_direction (self->priv->menubars, GTK_PACK_DIRECTION_TTB);
			gtk_widget_set_size_request ((GtkWidget*) self->priv->menubars, -1, (gint) panel_applet_get_size ((PanelApplet*) self));
			break;
		}
		case PANEL_APPLET_ORIENT_RIGHT:
		{
			gnomenu_menu_bar_box_set_gravity (self->priv->menubars, GNOMENU_GRAVITY_RIGHT);
			gnomenu_menu_bar_box_set_pack_direction (self->priv->menubars, GTK_PACK_DIRECTION_TTB);
			gnomenu_menu_bar_box_set_child_pack_direction (self->priv->menubars, GTK_PACK_DIRECTION_TTB);
			gtk_widget_set_size_request ((GtkWidget*) self->priv->menubars, -1, (gint) panel_applet_get_size ((PanelApplet*) self));
			break;
		}
	}
}


static void _lambda4_ (const char* key, void* value, GlobalMenuPanelApplet* self) {
	g_return_if_fail (key != NULL);
	applet_get_prefs (self);
}


static void __lambda4__gconf_client_value_changed (GConfClient* _sender, const char* key, void* value, gpointer self) {
	_lambda4_ (key, value, self);
}


void applet_init (GlobalMenuPanelApplet* self) {
	GError * _inner_error_;
	GConfClient* _tmp0_;
	GConfClient* client;
	char* applet_menu_xml;
	g_return_if_fail (self != NULL);
	_inner_error_ = NULL;
	{
		panel_applet_add_preferences ((PanelApplet*) self, APPLET_GCONF_SCHEMA_DIR, &_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch0_g_error;
			goto __finally0;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			g_warning ("applet.vala:209: %s", e->message);
			(e == NULL) ? NULL : (e = (g_error_free (e), NULL));
		}
	}
	__finally0:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
		g_clear_error (&_inner_error_);
		return;
	}
	_tmp0_ = NULL;
	client = (_tmp0_ = gconf_client_get_default (), (_tmp0_ == NULL) ? NULL : g_object_ref (_tmp0_));
	if (client != NULL) {
		g_signal_connect (client, "value-changed", (GCallback) __lambda4__gconf_client_value_changed, self);
	}
	applet_menu_xml = template_replace (APPLET_applet_menu_xml_template, applet_subs, applet_subs_length1);
	panel_applet_setup_menu ((PanelApplet*) self, applet_menu_xml, APPLET_verbs, self);
	applet_get_prefs (self);
	self->priv->initialized = TRUE;
	applet_check_module (self);
	(client == NULL) ? NULL : (client = (g_object_unref (client), NULL));
	applet_menu_xml = (g_free (applet_menu_xml), NULL);
}


static void applet_check_module (GlobalMenuPanelApplet* self) {
	GError * _inner_error_;
	const char* _tmp0_;
	char* modules;
	GtkSettings* _tmp2_;
	GtkSettings* settings;
	g_return_if_fail (self != NULL);
	_inner_error_ = NULL;
	if (!self->priv->initialized) {
		return;
	}
	if (self->disable_module_check) {
		return;
	}
	_tmp0_ = NULL;
	modules = (_tmp0_ = g_getenv ("GTK_MODULES"), (_tmp0_ == NULL) ? NULL : g_strdup (_tmp0_));
	if (modules == NULL) {
		char* _tmp1_;
		_tmp1_ = NULL;
		modules = (_tmp1_ = g_strdup (""), modules = (g_free (modules), NULL), _tmp1_);
	}
	_tmp2_ = NULL;
	settings = (_tmp2_ = gtk_widget_get_settings ((GtkWidget*) self), (_tmp2_ == NULL) ? NULL : g_object_ref (_tmp2_));
	if (settings != NULL) {
		char* _tmp5_;
		char* _tmp4_;
		char* _tmp3_;
		_tmp5_ = NULL;
		_tmp4_ = NULL;
		_tmp3_ = NULL;
		modules = (_tmp5_ = g_strconcat (modules, _tmp4_ = (g_object_get (settings, "gtk-modules", &_tmp3_, NULL), _tmp3_), NULL), modules = (g_free (modules), NULL), _tmp5_);
		_tmp4_ = (g_free (_tmp4_), NULL);
	}
	if (strstr (modules, "globalmenu") != NULL) {
		modules = (g_free (modules), NULL);
		(settings == NULL) ? NULL : (settings = (g_object_unref (settings), NULL));
		return;
	}
	{
		NotifyNotification* _tmp8_;
		char* _tmp7_;
		char* _tmp6_;
		notify_init (APPLET_APPLET_NAME);
		_tmp8_ = NULL;
		_tmp7_ = NULL;
		_tmp6_ = NULL;
		self->priv->notify_no_plugin = (_tmp8_ = notify_notification_new (_ ("No Global Menu?"), _tmp7_ = g_strconcat (_tmp6_ = g_strconcat (_ ("The Global Menu Plugin is not enabled on this desktop."), _ ("Enable the plugin by accessing the preferences dialog via a right-click,"), NULL), _ ("or by exporting GTK_MODULES=globalmenu-gnome in your profile."), NULL), "globalmenu", NULL), (self->priv->notify_no_plugin == NULL) ? NULL : (self->priv->notify_no_plugin = (g_object_unref (self->priv->notify_no_plugin), NULL)), _tmp8_);
		_tmp7_ = (g_free (_tmp7_), NULL);
		_tmp6_ = (g_free (_tmp6_), NULL);
		notify_notification_show (self->priv->notify_no_plugin, &_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch1_g_error;
			goto __finally1;
		}
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			/*ignore the error*/
			g_warning ("applet.vala:255: notify library doesn't work as intended");
			(e == NULL) ? NULL : (e = (g_error_free (e), NULL));
		}
	}
	__finally1:
	if (_inner_error_ != NULL) {
		modules = (g_free (modules), NULL);
		(settings == NULL) ? NULL : (settings = (g_object_unref (settings), NULL));
		g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
		g_clear_error (&_inner_error_);
		return;
	}
	modules = (g_free (modules), NULL);
	(settings == NULL) ? NULL : (settings = (g_object_unref (settings), NULL));
}


static void applet_get_prefs (GlobalMenuPanelApplet* self) {
	GError * _inner_error_;
	gint _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
	g_return_if_fail (self != NULL);
	_inner_error_ = NULL;
	_tmp0_ = panel_applet_gconf_get_int ((PanelApplet*) self, "title_max_width", &_inner_error_);
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
		g_clear_error (&_inner_error_);
		return;
	}
	switcher_set_max_size (self->priv->switcher, _tmp0_);
	_tmp1_ = panel_applet_gconf_get_bool ((PanelApplet*) self, "show_icon", &_inner_error_);
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
		g_clear_error (&_inner_error_);
		return;
	}
	switcher_set_show_icon (self->priv->switcher, _tmp1_);
	_tmp2_ = panel_applet_gconf_get_bool ((PanelApplet*) self, "show_name", &_inner_error_);
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
		g_clear_error (&_inner_error_);
		return;
	}
	switcher_set_show_label (self->priv->switcher, _tmp2_);
	_tmp3_ = panel_applet_gconf_get_bool ((PanelApplet*) self, "show_window_actions", &_inner_error_);
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
		g_clear_error (&_inner_error_);
		return;
	}
	switcher_set_show_window_actions (self->priv->switcher, _tmp3_);
	_tmp4_ = panel_applet_gconf_get_bool ((PanelApplet*) self, "show_window_list", &_inner_error_);
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
		g_clear_error (&_inner_error_);
		return;
	}
	switcher_set_show_window_list (self->priv->switcher, _tmp4_);
	_tmp5_ = panel_applet_gconf_get_bool ((PanelApplet*) self, "has_handle", &_inner_error_);
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
		g_clear_error (&_inner_error_);
		return;
	}
	applet_set_has_handle (self, _tmp5_);
	_tmp6_ = panel_applet_gconf_get_bool ((PanelApplet*) self, "disable_module_check", &_inner_error_);
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
		g_clear_error (&_inner_error_);
		return;
	}
	self->disable_module_check = _tmp6_;
}


static void applet_applet_menu_clicked (BonoboUIComponent* component, GlobalMenuPanelApplet* self, const char* cname) {
	GQuark _tmp1_;
	const char* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (component != NULL);
	g_return_if_fail (cname != NULL);
	_tmp0_ = NULL;
	static GQuark _tmp1__label0 = 0;
	static GQuark _tmp1__label1 = 0;
	static GQuark _tmp1__label2 = 0;
	_tmp0_ = cname;
	_tmp1_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
	if (_tmp1_ == ((0 != _tmp1__label0) ? _tmp1__label0 : (_tmp1__label0 = g_quark_from_static_string ("About"))))
	do {
		applet_show_about (self);
		break;
	} while (0); else if (_tmp1_ == ((0 != _tmp1__label1) ? _tmp1__label1 : (_tmp1__label1 = g_quark_from_static_string ("Preferences"))))
	do {
		applet_show_preferences (self);
		break;
	} while (0); else if (_tmp1_ == ((0 != _tmp1__label2) ? _tmp1__label2 : (_tmp1__label2 = g_quark_from_static_string ("Help"))))
	do {
		applet_show_help (self);
		break;
	} while (0);
}


static void applet_show_about (GlobalMenuPanelApplet* self) {
	GError * _inner_error_;
	GtkAboutDialog* dialog;
	char* ver;
	g_return_if_fail (self != NULL);
	_inner_error_ = NULL;
	dialog = g_object_ref_sink ((GtkAboutDialog*) gtk_about_dialog_new ());
	gtk_about_dialog_set_program_name (dialog, APPLET_APPLET_NAME);
	ver = g_strdup (VERSION);
	gtk_about_dialog_set_version (dialog, ver);
	gtk_about_dialog_set_website (dialog, "http://code.google.com/p/gnome2-globalmenu");
	gtk_about_dialog_set_website_label (dialog, _ ("Project Home"));
	gtk_about_dialog_set_wrap_license (dialog, FALSE);
	{
		char* license;
		char* _tmp2_;
		gboolean _tmp1_;
		char* _tmp0_;
		license = NULL;
		_tmp2_ = NULL;
		_tmp0_ = NULL;
		_tmp1_ = g_file_get_contents (DOCDIR "/COPYING", &_tmp0_, NULL, &_inner_error_);
		license = (_tmp2_ = _tmp0_, license = (g_free (license), NULL), _tmp2_);
		_tmp1_;
		if (_inner_error_ != NULL) {
			license = (g_free (license), NULL);
			if (_inner_error_->domain == G_FILE_ERROR) {
				goto __catch2_g_file_error;
			}
			goto __finally2;
		}
		gtk_about_dialog_set_license (dialog, license);
		license = (g_free (license), NULL);
	}
	goto __finally2;
	__catch2_g_file_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			g_warning ("applet.vala:299: %s", e->message);
			(e == NULL) ? NULL : (e = (g_error_free (e), NULL));
		}
	}
	__finally2:
	if (_inner_error_ != NULL) {
		(dialog == NULL) ? NULL : (dialog = (g_object_unref (dialog), NULL));
		ver = (g_free (ver), NULL);
		g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
		g_clear_error (&_inner_error_);
		return;
	}
	{
		char* authors;
		char* _tmp5_;
		gboolean _tmp4_;
		char* _tmp3_;
		char** _tmp7_;
		gint authors_array_size;
		gint authors_array_length1;
		char** _tmp6_;
		char** authors_array;
		authors = NULL;
		_tmp5_ = NULL;
		_tmp3_ = NULL;
		_tmp4_ = g_file_get_contents (DOCDIR "/AUTHORS", &_tmp3_, NULL, &_inner_error_);
		authors = (_tmp5_ = _tmp3_, authors = (g_free (authors), NULL), _tmp5_);
		_tmp4_;
		if (_inner_error_ != NULL) {
			authors = (g_free (authors), NULL);
			if (_inner_error_->domain == G_FILE_ERROR) {
				goto __catch3_g_file_error;
			}
			goto __finally3;
		}
		_tmp7_ = NULL;
		_tmp6_ = NULL;
		authors_array = (_tmp7_ = _tmp6_ = g_strsplit (authors, "\n", 0), authors_array_length1 = _vala_array_length (_tmp6_), authors_array_size = authors_array_length1, _tmp7_);
		gtk_about_dialog_set_authors (dialog, authors_array);
		authors = (g_free (authors), NULL);
		authors_array = (_vala_array_free (authors_array, authors_array_length1, (GDestroyNotify) g_free), NULL);
	}
	goto __finally3;
	__catch3_g_file_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			g_warning ("applet.vala:307: %s", e->message);
			(e == NULL) ? NULL : (e = (g_error_free (e), NULL));
		}
	}
	__finally3:
	if (_inner_error_ != NULL) {
		(dialog == NULL) ? NULL : (dialog = (g_object_unref (dialog), NULL));
		ver = (g_free (ver), NULL);
		g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
		g_clear_error (&_inner_error_);
		return;
	}
	gtk_about_dialog_set_logo_icon_name (dialog, APPLET_APPLET_ICON);
	gtk_about_dialog_set_translator_credits (dialog, _ ("translator-credits"));
	gtk_window_set_icon_name ((GtkWindow*) dialog, "gtk-about");
	gtk_dialog_run ((GtkDialog*) dialog);
	gtk_object_destroy ((GtkObject*) dialog);
	(dialog == NULL) ? NULL : (dialog = (g_object_unref (dialog), NULL));
	ver = (g_free (ver), NULL);
}


static void applet_show_preferences (GlobalMenuPanelApplet* self) {
	GConfDialog* gcd;
	char* root;
	gint _tmp1__length1;
	char** _tmp1_;
	char** _tmp0_;
	gint _tmp3__length1;
	char** _tmp3_;
	char** _tmp2_;
	g_return_if_fail (self != NULL);
	gcd = g_object_ref_sink (gconf_dialog_new (_ ("Global Menu Applet Preferences")));
	root = panel_applet_get_preferences_key ((PanelApplet*) self);
	_tmp1_ = NULL;
	_tmp0_ = NULL;
	gconf_dialog_add_key_group (gcd, _ ("System Preferences"), (_tmp1_ = (_tmp0_ = g_new0 (char*, 2 + 1), _tmp0_[0] = g_strdup ("/apps/gnome_settings_daemon/gtk-modules/globalmenu-gnome"), _tmp0_[1] = g_strconcat (root, "/disable_module_check", NULL), _tmp0_), _tmp1__length1 = 2, _tmp1_), 2);
	_tmp1_ = (_vala_array_free (_tmp1_, _tmp1__length1, (GDestroyNotify) g_free), NULL);
	_tmp3_ = NULL;
	_tmp2_ = NULL;
	gconf_dialog_add_key_group (gcd, _ ("Applet Behaviors"), (_tmp3_ = (_tmp2_ = g_new0 (char*, 6 + 1), _tmp2_[0] = g_strconcat (root, "/has_handle", NULL), _tmp2_[1] = g_strconcat (root, "/show_icon", NULL), _tmp2_[2] = g_strconcat (root, "/show_name", NULL), _tmp2_[3] = g_strconcat (root, "/title_max_width", NULL), _tmp2_[4] = g_strconcat (root, "/show_window_actions", NULL), _tmp2_[5] = g_strconcat (root, "/show_window_list", NULL), _tmp2_), _tmp3__length1 = 6, _tmp3_), 6);
	_tmp3_ = (_vala_array_free (_tmp3_, _tmp3__length1, (GDestroyNotify) g_free), NULL);
	switch (gtk_dialog_run ((GtkDialog*) gcd)) {
		case GTK_RESPONSE_HELP:
		{
			applet_show_help (self);
			break;
		}
	}
	gtk_object_destroy ((GtkObject*) gcd);
	(gcd == NULL) ? NULL : (gcd = (g_object_unref (gcd), NULL));
	root = (g_free (root), NULL);
}


static void applet_show_help (GlobalMenuPanelApplet* self) {
	GError * _inner_error_;
	g_return_if_fail (self != NULL);
	_inner_error_ = NULL;
	{
		gnome_url_show ("http://code.google.com/p/gnome2-globalmenu/wiki/HelpCentral", &_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch4_g_error;
			goto __finally4;
		}
	}
	goto __finally4;
	__catch4_g_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			g_warning ("applet.vala:353: %s", e->message);
			(e == NULL) ? NULL : (e = (g_error_free (e), NULL));
		}
	}
	__finally4:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
		g_clear_error (&_inner_error_);
		return;
	}
}


static gboolean applet_real_button_press_event (GtkWidget* base, const GdkEventButton* event) {
	GlobalMenuPanelApplet * self;
	self = (GlobalMenuPanelApplet*) base;
	if ((*event).button == 3) {
		return bonobo_control_do_popup (panel_applet_get_control ((PanelApplet*) self), (*event).button, (*event).time);
	}
	return FALSE;
}


static void applet_real_size_request (GtkWidget* base, GtkRequisition* req) {
	GlobalMenuPanelApplet * self;
	gint* _tmp1_;
	gint hints_size;
	gint hints_length1;
	gint _tmp0_;
	gint* hints;
	self = (GlobalMenuPanelApplet*) base;
	GTK_WIDGET_CLASS (applet_parent_class)->size_request ((GtkWidget*) PANEL_APPLET (self), &(*req));
	_tmp1_ = NULL;
	hints = (_tmp1_ = gnomenu_menu_bar_box_get_size_hints (self->priv->menubars, &_tmp0_), hints_length1 = _tmp0_, hints_size = hints_length1, _tmp1_);
	g_assert ((hints_length1 % 2) == 0);
	if (applet_get_has_handle (self)) {
		/* This is to workaround a problem with gnome panel.
		 * gnome panel won't handle size_hints correctly if
		 * the applet has no handle.
		 *
		 * Take a look at the sample code of gnome-panel/applets/wncklets
		 * */
		panel_applet_set_size_hints ((PanelApplet*) self, hints, hints_length1, 0);
	}
}


static gboolean _lambda5_ (GtkWidget* widget, const GdkEventButton* event, GlobalMenuPanelApplet* self) {
	g_return_val_if_fail (widget != NULL, FALSE);
	if ((*event).button == 3) {
		gboolean _tmp1_;
		GlobalMenuPanelApplet* _tmp0_;
		_tmp0_ = NULL;
		g_signal_emit_by_name ((_tmp0_ = self, GTK_IS_WIDGET (_tmp0_) ? ((GtkWidget*) _tmp0_) : NULL), "button-press-event", &(*event), &_tmp1_);
		_tmp1_;
		return TRUE;
	} else {
		return FALSE;
	}
}


static gboolean __lambda5__gtk_widget_button_press_event (GtkWidget* _sender, const GdkEventButton* event, gpointer self) {
	return _lambda5_ (_sender, event, self);
}


static void applet_setup_popup_menu (GlobalMenuPanelApplet* self, GtkWidget* widget) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (widget != NULL);
	g_signal_connect (widget, "button-press-event", (GCallback) __lambda5__gtk_widget_button_press_event, self);
}


gboolean applet_get_has_handle (GlobalMenuPanelApplet* self) {
	g_return_val_if_fail (self != NULL, FALSE);
	return self->priv->_has_handle;
}


void applet_set_has_handle (GlobalMenuPanelApplet* self, gboolean value) {
	g_return_if_fail (self != NULL);
	if (value) {
		panel_applet_set_flags ((PanelApplet*) self, ((0 | PANEL_APPLET_HAS_HANDLE) | PANEL_APPLET_EXPAND_MINOR) | PANEL_APPLET_EXPAND_MAJOR);
	} else {
		panel_applet_set_flags ((PanelApplet*) self, (0 | PANEL_APPLET_EXPAND_MINOR) | PANEL_APPLET_EXPAND_MAJOR);
		panel_applet_set_size_hints ((PanelApplet*) self, NULL, 0, 0);
	}
	self->priv->_has_handle = value;
	g_object_notify ((GObject *) self, "has-handle");
}


static void _applet_on_window_changed_gnomenu_monitor_window_changed (GnomenuMonitor* _sender, gulong old_xid, gpointer self) {
	applet_on_window_changed (self, _sender, old_xid);
}


static GObject * applet_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GlobalMenuPanelAppletClass * klass;
	GObjectClass * parent_class;
	GlobalMenuPanelApplet * self;
	klass = APPLET_CLASS (g_type_class_peek (TYPE_APPLET));
	parent_class = G_OBJECT_CLASS (g_type_class_peek_parent (klass));
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = APPLET (obj);
	{
		GdkColor color = {0};
		GdkPixmap* pixmap;
		PanelAppletBackgroundType bgtype;
		GdkPixmap* _tmp6_;
		PanelAppletBackgroundType _tmp5_;
		GdkPixmap* _tmp4_;
		GlobalMenuPanelApplet* _tmp7_;
		gtk_widget_add_events ((GtkWidget*) self, (gint) GDK_KEY_PRESS_MASK);
		g_object_set ((GtkWidget*) self->priv->menubars, "visible", TRUE, NULL);
		gtk_container_add ((GtkContainer*) self, (GtkWidget*) self->priv->menubars);
		g_object_set ((GtkWidget*) self->priv->switcher, "visible", TRUE, NULL);
		gtk_container_add ((GtkContainer*) self->priv->menubars, (GtkWidget*) self->priv->switcher);
		applet_setup_popup_menu (self, (GtkWidget*) self->priv->switcher);
		applet_setup_popup_menu (self, (GtkWidget*) self->priv->main_menubar);
		gtk_container_add ((GtkContainer*) self->priv->menubars, (GtkWidget*) self->priv->main_menubar);
		gtk_container_child_set ((GtkContainer*) self->priv->menubars, (GtkWidget*) self->priv->main_menubar, "shrink", TRUE, NULL, NULL);
		/*init panel */
		applet_set_has_handle (self, FALSE);
		panel_applet_set_background_widget ((PanelApplet*) self, (GtkWidget*) self);
		pixmap = NULL;
		bgtype = 0;
		_tmp6_ = NULL;
		_tmp4_ = NULL;
		bgtype = (_tmp5_ = panel_applet_get_background ((PanelApplet*) self, &color, &_tmp4_), pixmap = (_tmp6_ = _tmp4_, (pixmap == NULL) ? NULL : (pixmap = (g_object_unref (pixmap), NULL)), _tmp6_), _tmp5_);
		_tmp7_ = NULL;
		g_signal_emit_by_name ((_tmp7_ = self, PANEL_IS_APPLET (_tmp7_) ? ((PanelApplet*) _tmp7_) : NULL), "change-background", bgtype, &color, pixmap);
		g_signal_connect_object (self->priv->monitor, "window-changed", (GCallback) _applet_on_window_changed_gnomenu_monitor_window_changed, self, 0);
		applet_on_window_changed (self, self->priv->monitor, (gulong) 0);
		(pixmap == NULL) ? NULL : (pixmap = (g_object_unref (pixmap), NULL));
	}
	return obj;
}


static void applet_class_init (GlobalMenuPanelAppletClass * klass) {
	char** _tmp3_;
	const char* _tmp2_;
	const char* _tmp1_;
	const char* _tmp0_;
	applet_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GlobalMenuPanelAppletPrivate));
	G_OBJECT_CLASS (klass)->dispose = applet_real_dispose;
	GTK_WIDGET_CLASS (klass)->screen_changed = applet_real_screen_changed;
	PANEL_APPLET_CLASS (klass)->change_background = applet_real_change_background;
	PANEL_APPLET_CLASS (klass)->change_orient = applet_real_change_orient;
	PANEL_APPLET_CLASS (klass)->change_size = applet_real_change_size;
	GTK_WIDGET_CLASS (klass)->button_press_event = applet_real_button_press_event;
	GTK_WIDGET_CLASS (klass)->size_request = applet_real_size_request;
	G_OBJECT_CLASS (klass)->get_property = applet_get_property;
	G_OBJECT_CLASS (klass)->set_property = applet_set_property;
	G_OBJECT_CLASS (klass)->constructor = applet_constructor;
	G_OBJECT_CLASS (klass)->finalize = applet_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLET_HAS_HANDLE, g_param_spec_boolean ("has-handle", "has-handle", "has-handle", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	applet_subs = (_tmp3_ = g_new0 (char*, 6 + 1), _tmp3_[0] = g_strdup ("@Preferences@"), _tmp3_[1] = (_tmp0_ = _ ("_Preferences"), (_tmp0_ == NULL) ? NULL : g_strdup (_tmp0_)), _tmp3_[2] = g_strdup ("@Help@"), _tmp3_[3] = (_tmp1_ = _ ("_Help"), (_tmp1_ == NULL) ? NULL : g_strdup (_tmp1_)), _tmp3_[4] = g_strdup ("@About@"), _tmp3_[5] = (_tmp2_ = _ ("_About"), (_tmp2_ == NULL) ? NULL : g_strdup (_tmp2_)), _tmp3_);
	applet_subs_length1 = 6;
	_tmp3_ = NULL;
	_tmp2_ = NULL;
	_tmp1_ = NULL;
	_tmp0_ = NULL;
}


static void applet_instance_init (GlobalMenuPanelApplet * self) {
	self->priv = APPLET_GET_PRIVATE (self);
	self->priv->monitor = gnomenu_monitor_new ();
	self->priv->menubars = g_object_ref_sink (gnomenu_menu_bar_box_new ());
	self->priv->disposed = FALSE;
	self->priv->main_menubar = g_object_ref_sink (gnomenu_global_menu_new ());
	self->priv->switcher = g_object_ref_sink (switcher_new ());
	self->priv->initialized = FALSE;
	self->disable_module_check = FALSE;
	self->priv->_has_handle = FALSE;
}


static void applet_finalize (GObject* obj) {
	GlobalMenuPanelApplet * self;
	self = APPLET (obj);
	(self->priv->monitor == NULL) ? NULL : (self->priv->monitor = (g_object_unref (self->priv->monitor), NULL));
	(self->priv->menubars == NULL) ? NULL : (self->priv->menubars = (g_object_unref (self->priv->menubars), NULL));
	(self->priv->main_menubar == NULL) ? NULL : (self->priv->main_menubar = (g_object_unref (self->priv->main_menubar), NULL));
	(self->priv->switcher == NULL) ? NULL : (self->priv->switcher = (g_object_unref (self->priv->switcher), NULL));
	(self->priv->notify_no_plugin == NULL) ? NULL : (self->priv->notify_no_plugin = (g_object_unref (self->priv->notify_no_plugin), NULL));
	G_OBJECT_CLASS (applet_parent_class)->finalize (obj);
}


GType applet_get_type (void) {
	static GType applet_type_id = 0;
	if (applet_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (GlobalMenuPanelAppletClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) applet_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GlobalMenuPanelApplet), 0, (GInstanceInitFunc) applet_instance_init, NULL };
		applet_type_id = g_type_register_static (PANEL_TYPE_APPLET, "GlobalMenuPanelApplet", &g_define_type_info, 0);
	}
	return applet_type_id;
}


static void applet_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	GlobalMenuPanelApplet * self;
	gpointer boxed;
	self = APPLET (object);
	switch (property_id) {
		case APPLET_HAS_HANDLE:
		g_value_set_boolean (value, applet_get_has_handle (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void applet_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	GlobalMenuPanelApplet * self;
	self = APPLET (object);
	switch (property_id) {
		case APPLET_HAS_HANDLE:
		applet_set_has_handle (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}




