
#include <glib.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <configmake.h>
#include <gtk/gtk.h>
#include <bonobo-activation/bonobo-activation-init.h>
#include <stdlib.h>
#include <string.h>
#include <bonobo/bonobo-main.h>
#include <panel-applet.h>


#define TYPE_APPLET (applet_get_type ())
#define APPLET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_APPLET, GlobalMenuPanelApplet))
#define APPLET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_APPLET, GlobalMenuPanelAppletClass))
#define IS_APPLET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_APPLET))
#define IS_APPLET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_APPLET))
#define APPLET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_APPLET, GlobalMenuPanelAppletClass))

typedef struct _GlobalMenuPanelApplet GlobalMenuPanelApplet;
typedef struct _GlobalMenuPanelAppletClass GlobalMenuPanelAppletClass;



#define FACTORY_IID "OAFIID:GlobalMenu_PanelApplet_Factory"
extern gboolean verbose;
gboolean verbose = FALSE;
static void _lambda6_ (const char* domain, GLogLevelFlags level, const char* message);
static void __lambda6__glog_func (const char* log_domain, GLogLevelFlags log_levels, const char* message, gpointer self);
GType applet_get_type (void);
#define APPLET_IID "OAFIID:GlobalMenu_PanelApplet"
void applet_init (GlobalMenuPanelApplet* self);
static gboolean _lambda7_ (PanelApplet* applet, const char* iid);
static gboolean __lambda7__panel_applet_factory_callback (PanelApplet* applet, const char* iid, gpointer self);
gint _main (char** args, int args_length1);
static int _vala_strcmp0 (const char * str1, const char * str2);

static const GOptionEntry options[] = {{"verbose", 'v', 0, G_OPTION_ARG_NONE, &verbose, N_ ("Be verbose"), NULL}, {NULL}};


static void _lambda6_ (const char* domain, GLogLevelFlags level, const char* message) {
	g_return_if_fail (message != NULL);
}


static void __lambda6__glog_func (const char* log_domain, GLogLevelFlags log_levels, const char* message, gpointer self) {
	_lambda6_ (log_domain, log_levels, message);
}


static gboolean _lambda7_ (PanelApplet* applet, const char* iid) {
	g_return_val_if_fail (applet != NULL, FALSE);
	g_return_val_if_fail (iid != NULL, FALSE);
	if (_vala_strcmp0 (iid, APPLET_IID) == 0) {
		PanelApplet* _tmp0_;
		_tmp0_ = NULL;
		applet_init ((_tmp0_ = applet, IS_APPLET (_tmp0_) ? ((GlobalMenuPanelApplet*) _tmp0_) : NULL));
		gtk_widget_show ((GtkWidget*) applet);
		return TRUE;
	} else {
		return FALSE;
	}
}


static gboolean __lambda7__panel_applet_factory_callback (PanelApplet* applet, const char* iid, gpointer self) {
	return _lambda7_ (applet, iid);
}


gint _main (char** args, int args_length1) {
	GError * _inner_error_;
	GOptionContext* context;
	gint retval;
	gint _tmp1_;
	_inner_error_ = NULL;
	bindtextdomain (GETTEXT_PACKAGE, LOCALEDIR);
	bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
	textdomain (GETTEXT_PACKAGE);
	context = g_option_context_new ("- GlobalMenu.PanelApplet");
	g_option_context_set_help_enabled (context, TRUE);
	g_option_context_add_main_entries (context, options, NULL);
	g_option_context_add_group (context, gtk_get_option_group (TRUE));
	g_option_context_add_group (context, bonobo_activation_get_goption_group ());
	{
		g_option_context_parse (context, &args_length1, &args, &_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch5_g_error;
			goto __finally5;
		}
	}
	goto __finally5;
	__catch5_g_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			g_error ("main.vala:24: parsing options failed: %s", e->message);
			(e == NULL) ? NULL : (e = (g_error_free (e), NULL));
		}
	}
	__finally5:
	if (_inner_error_ != NULL) {
		(context == NULL) ? NULL : (context = (g_option_context_free (context), NULL));
		g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
		g_clear_error (&_inner_error_);
		return 0;
	}
	if (!verbose) {
		GLogFunc _tmp0_;
		void* handler_target;
		GLogFunc handler;
		handler_target = NULL;
		handler = (_tmp0_ = __lambda6__glog_func, handler_target = NULL, _tmp0_);
		g_log_set_handler ("libgnomenu", G_LOG_LEVEL_DEBUG, handler, handler_target);
		g_log_set_handler (NULL, G_LOG_LEVEL_DEBUG, handler, handler_target);
	}
	gtk_rc_parse_string ("\n\t\tstyle \"globalmenu_event_box_style\"\n\t\t{\n\t\t\tGtkWidget::focus-line-width=0\n\t\t\tGtkWidget::focus-padding=0\n\t\t}\n\t\tstyle \"globalmenu_menu_bar_style\"\n\t\t{\n\t\t\tythickness = 0\n\t\t\tGtkMenuBar::shadow-type = none\n\t\t\tGtkMenuBar::internal-padding = 0\n\t\t}\n\t\tclass \"GtkEventBox\" style \"globalmenu_event_box_style\"\n\t\tclass \"GnomenuMenuBar\" style:highest \"globalmenu_menu_bar_style\"\n");
	gtk_init (&args_length1, &args);
	if (!bonobo_init (&args_length1, args)) {
		g_error ("main.vala:51: Cannot initialize bonobo.");
	}
	retval = panel_applet_factory_main (FACTORY_IID, TYPE_APPLET, __lambda7__panel_applet_factory_callback, NULL);
	return (_tmp1_ = retval, (context == NULL) ? NULL : (context = (g_option_context_free (context), NULL)), _tmp1_);
}


int main (int argc, char ** argv) {
	g_type_init ();
	return _main (argv, argc);
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}




