
#ifndef __LIBGNOMENU_H__
#define __LIBGNOMENU_H__

#include <glib.h>
#include <float.h>
#include <math.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <libwnck/libwnck.h>
#include <gdk-pixbuf/gdk-pixdata.h>

G_BEGIN_DECLS


#define GNOMENU_TYPE_BACKGROUND_TYPE (gnomenu_background_type_get_type ())

#define GNOMENU_TYPE_GRAVITY (gnomenu_gravity_get_type ())

#define GNOMENU_TYPE_PARSER (gnomenu_parser_get_type ())
#define GNOMENU_PARSER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNOMENU_TYPE_PARSER, GnomenuParser))
#define GNOMENU_PARSER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNOMENU_TYPE_PARSER, GnomenuParserClass))
#define GNOMENU_IS_PARSER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNOMENU_TYPE_PARSER))
#define GNOMENU_IS_PARSER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNOMENU_TYPE_PARSER))
#define GNOMENU_PARSER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNOMENU_TYPE_PARSER, GnomenuParserClass))

typedef struct _GnomenuParser GnomenuParser;
typedef struct _GnomenuParserClass GnomenuParserClass;
typedef struct _GnomenuParserPrivate GnomenuParserPrivate;

#define GNOMENU_TYPE_SHELL (gnomenu_shell_get_type ())
#define GNOMENU_SHELL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNOMENU_TYPE_SHELL, GnomenuShell))
#define GNOMENU_IS_SHELL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNOMENU_TYPE_SHELL))
#define GNOMENU_SHELL_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GNOMENU_TYPE_SHELL, GnomenuShellIface))

typedef struct _GnomenuShell GnomenuShell;
typedef struct _GnomenuShellIface GnomenuShellIface;

#define GNOMENU_TYPE_ITEM (gnomenu_item_get_type ())
#define GNOMENU_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNOMENU_TYPE_ITEM, GnomenuItem))
#define GNOMENU_IS_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNOMENU_TYPE_ITEM))
#define GNOMENU_ITEM_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GNOMENU_TYPE_ITEM, GnomenuItemIface))

typedef struct _GnomenuItem GnomenuItem;
typedef struct _GnomenuItemIface GnomenuItemIface;

#define GNOMENU_TYPE_ITEM_TYPE (gnomenu_item_type_get_type ())

#define GNOMENU_TYPE_ITEM_STATE (gnomenu_item_state_get_type ())

#define GNOMENU_TYPE_SERIALIZER (gnomenu_serializer_get_type ())
#define GNOMENU_SERIALIZER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNOMENU_TYPE_SERIALIZER, GnomenuSerializer))
#define GNOMENU_SERIALIZER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNOMENU_TYPE_SERIALIZER, GnomenuSerializerClass))
#define GNOMENU_IS_SERIALIZER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNOMENU_TYPE_SERIALIZER))
#define GNOMENU_IS_SERIALIZER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNOMENU_TYPE_SERIALIZER))
#define GNOMENU_SERIALIZER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNOMENU_TYPE_SERIALIZER, GnomenuSerializerClass))

typedef struct _GnomenuSerializer GnomenuSerializer;
typedef struct _GnomenuSerializerClass GnomenuSerializerClass;
typedef struct _GnomenuSerializerPrivate GnomenuSerializerPrivate;

#define GNOMENU_TYPE_MENU (gnomenu_menu_get_type ())
#define GNOMENU_MENU(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNOMENU_TYPE_MENU, GnomenuMenu))
#define GNOMENU_MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNOMENU_TYPE_MENU, GnomenuMenuClass))
#define GNOMENU_IS_MENU(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNOMENU_TYPE_MENU))
#define GNOMENU_IS_MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNOMENU_TYPE_MENU))
#define GNOMENU_MENU_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNOMENU_TYPE_MENU, GnomenuMenuClass))

typedef struct _GnomenuMenu GnomenuMenu;
typedef struct _GnomenuMenuClass GnomenuMenuClass;
typedef struct _GnomenuMenuPrivate GnomenuMenuPrivate;

#define GNOMENU_TYPE_BACKGROUND (gnomenu_background_get_type ())
#define GNOMENU_BACKGROUND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNOMENU_TYPE_BACKGROUND, GnomenuBackground))
#define GNOMENU_BACKGROUND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNOMENU_TYPE_BACKGROUND, GnomenuBackgroundClass))
#define GNOMENU_IS_BACKGROUND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNOMENU_TYPE_BACKGROUND))
#define GNOMENU_IS_BACKGROUND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNOMENU_TYPE_BACKGROUND))
#define GNOMENU_BACKGROUND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNOMENU_TYPE_BACKGROUND, GnomenuBackgroundClass))

typedef struct _GnomenuBackground GnomenuBackground;
typedef struct _GnomenuBackgroundClass GnomenuBackgroundClass;
typedef struct _GnomenuBackgroundPrivate GnomenuBackgroundPrivate;

#define GNOMENU_TYPE_MENU_BAR (gnomenu_menu_bar_get_type ())
#define GNOMENU_MENU_BAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNOMENU_TYPE_MENU_BAR, GnomenuMenuBar))
#define GNOMENU_MENU_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNOMENU_TYPE_MENU_BAR, GnomenuMenuBarClass))
#define GNOMENU_IS_MENU_BAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNOMENU_TYPE_MENU_BAR))
#define GNOMENU_IS_MENU_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNOMENU_TYPE_MENU_BAR))
#define GNOMENU_MENU_BAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNOMENU_TYPE_MENU_BAR, GnomenuMenuBarClass))

typedef struct _GnomenuMenuBar GnomenuMenuBar;
typedef struct _GnomenuMenuBarClass GnomenuMenuBarClass;
typedef struct _GnomenuMenuBarPrivate GnomenuMenuBarPrivate;

#define GNOMENU_TYPE_MENU_ITEM (gnomenu_menu_item_get_type ())
#define GNOMENU_MENU_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNOMENU_TYPE_MENU_ITEM, GnomenuMenuItem))
#define GNOMENU_MENU_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNOMENU_TYPE_MENU_ITEM, GnomenuMenuItemClass))
#define GNOMENU_IS_MENU_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNOMENU_TYPE_MENU_ITEM))
#define GNOMENU_IS_MENU_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNOMENU_TYPE_MENU_ITEM))
#define GNOMENU_MENU_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNOMENU_TYPE_MENU_ITEM, GnomenuMenuItemClass))

typedef struct _GnomenuMenuItem GnomenuMenuItem;
typedef struct _GnomenuMenuItemClass GnomenuMenuItemClass;
typedef struct _GnomenuMenuItemPrivate GnomenuMenuItemPrivate;

#define GNOMENU_TYPE_WINDOW (gnomenu_window_get_type ())
#define GNOMENU_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNOMENU_TYPE_WINDOW, GnomenuWindow))
#define GNOMENU_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNOMENU_TYPE_WINDOW, GnomenuWindowClass))
#define GNOMENU_IS_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNOMENU_TYPE_WINDOW))
#define GNOMENU_IS_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNOMENU_TYPE_WINDOW))
#define GNOMENU_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNOMENU_TYPE_WINDOW, GnomenuWindowClass))

typedef struct _GnomenuWindow GnomenuWindow;
typedef struct _GnomenuWindowClass GnomenuWindowClass;
typedef struct _GnomenuWindowPrivate GnomenuWindowPrivate;

#define GNOMENU_TYPE_MENU_BAR_BOX (gnomenu_menu_bar_box_get_type ())
#define GNOMENU_MENU_BAR_BOX(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNOMENU_TYPE_MENU_BAR_BOX, GnomenuMenuBarBox))
#define GNOMENU_MENU_BAR_BOX_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNOMENU_TYPE_MENU_BAR_BOX, GnomenuMenuBarBoxClass))
#define GNOMENU_IS_MENU_BAR_BOX(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNOMENU_TYPE_MENU_BAR_BOX))
#define GNOMENU_IS_MENU_BAR_BOX_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNOMENU_TYPE_MENU_BAR_BOX))
#define GNOMENU_MENU_BAR_BOX_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNOMENU_TYPE_MENU_BAR_BOX, GnomenuMenuBarBoxClass))

typedef struct _GnomenuMenuBarBox GnomenuMenuBarBox;
typedef struct _GnomenuMenuBarBoxClass GnomenuMenuBarBoxClass;
typedef struct _GnomenuMenuBarBoxPrivate GnomenuMenuBarBoxPrivate;

#define GNOMENU_TYPE_MENU_LABEL (gnomenu_menu_label_get_type ())
#define GNOMENU_MENU_LABEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNOMENU_TYPE_MENU_LABEL, GnomenuMenuLabel))
#define GNOMENU_MENU_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNOMENU_TYPE_MENU_LABEL, GnomenuMenuLabelClass))
#define GNOMENU_IS_MENU_LABEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNOMENU_TYPE_MENU_LABEL))
#define GNOMENU_IS_MENU_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNOMENU_TYPE_MENU_LABEL))
#define GNOMENU_MENU_LABEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNOMENU_TYPE_MENU_LABEL, GnomenuMenuLabelClass))

typedef struct _GnomenuMenuLabel GnomenuMenuLabel;
typedef struct _GnomenuMenuLabelClass GnomenuMenuLabelClass;
typedef struct _GnomenuMenuLabelPrivate GnomenuMenuLabelPrivate;

#define GNOMENU_TYPE_GLOBAL_MENU (gnomenu_global_menu_get_type ())
#define GNOMENU_GLOBAL_MENU(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNOMENU_TYPE_GLOBAL_MENU, GnomenuGlobalMenu))
#define GNOMENU_GLOBAL_MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNOMENU_TYPE_GLOBAL_MENU, GnomenuGlobalMenuClass))
#define GNOMENU_IS_GLOBAL_MENU(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNOMENU_TYPE_GLOBAL_MENU))
#define GNOMENU_IS_GLOBAL_MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNOMENU_TYPE_GLOBAL_MENU))
#define GNOMENU_GLOBAL_MENU_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNOMENU_TYPE_GLOBAL_MENU, GnomenuGlobalMenuClass))

typedef struct _GnomenuGlobalMenu GnomenuGlobalMenu;
typedef struct _GnomenuGlobalMenuClass GnomenuGlobalMenuClass;
typedef struct _GnomenuGlobalMenuPrivate GnomenuGlobalMenuPrivate;

#define GNOMENU_TYPE_APPLICATION (gnomenu_application_get_type ())
#define GNOMENU_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNOMENU_TYPE_APPLICATION, GnomenuApplication))
#define GNOMENU_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNOMENU_TYPE_APPLICATION, GnomenuApplicationClass))
#define GNOMENU_IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNOMENU_TYPE_APPLICATION))
#define GNOMENU_IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNOMENU_TYPE_APPLICATION))
#define GNOMENU_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNOMENU_TYPE_APPLICATION, GnomenuApplicationClass))

typedef struct _GnomenuApplication GnomenuApplication;
typedef struct _GnomenuApplicationClass GnomenuApplicationClass;
typedef struct _GnomenuApplicationPrivate GnomenuApplicationPrivate;

#define GNOMENU_TYPE_MONITOR (gnomenu_monitor_get_type ())
#define GNOMENU_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNOMENU_TYPE_MONITOR, GnomenuMonitor))
#define GNOMENU_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNOMENU_TYPE_MONITOR, GnomenuMonitorClass))
#define GNOMENU_IS_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNOMENU_TYPE_MONITOR))
#define GNOMENU_IS_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNOMENU_TYPE_MONITOR))
#define GNOMENU_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNOMENU_TYPE_MONITOR, GnomenuMonitorClass))

typedef struct _GnomenuMonitor GnomenuMonitor;
typedef struct _GnomenuMonitorClass GnomenuMonitorClass;
typedef struct _GnomenuMonitorPrivate GnomenuMonitorPrivate;

typedef enum  {
	GNOMENU_BACKGROUND_TYPE_NONE = 0,
	GNOMENU_BACKGROUND_TYPE_COLOR = 1,
	GNOMENU_BACKGROUND_TYPE_PIXMAP = 2
} GnomenuBackgroundType;

typedef enum  {
	GNOMENU_GRAVITY_DOWN = 0,
	GNOMENU_GRAVITY_UP = 1,
	GNOMENU_GRAVITY_LEFT = 2,
	GNOMENU_GRAVITY_RIGHT = 3
} GnomenuGravity;

/**
 * Parser converts xml to widgets.
 *
 */
struct _GnomenuParser {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GnomenuParserPrivate * priv;
};

struct _GnomenuParserClass {
	GTypeClass parent_class;
	void (*finalize) (GnomenuParser *self);
};

typedef enum  {
	GNOMENU_ITEM_TYPE_NORMAL = 0,
	GNOMENU_ITEM_TYPE_CHECK = 1,
	GNOMENU_ITEM_TYPE_RADIO = 2,
	GNOMENU_ITEM_TYPE_IMAGE = 3,
	GNOMENU_ITEM_TYPE_SEPARATOR = 4,
	GNOMENU_ITEM_TYPE_ARROW = 5,
	GNOMENU_ITEM_TYPE_ICON = 6
} GnomenuItemType;

typedef enum  {
	GNOMENU_ITEM_STATE_UNTOGGLED = 0,
	GNOMENU_ITEM_STATE_TOGGLED = 1,
	GNOMENU_ITEM_STATE_TRISTATE = 2
} GnomenuItemState;

struct _GnomenuItemIface {
	GTypeInterface parent_iface;
	GnomenuShell* (*get_shell) (GnomenuItem* self);
	GnomenuShell* (*get_sub_shell) (GnomenuItem* self);
	gboolean (*get_has_sub_shell) (GnomenuItem* self);
	void (*set_has_sub_shell) (GnomenuItem* self, gboolean value);
	gboolean (*get_client_side_sub_shell) (GnomenuItem* self);
	void (*set_client_side_sub_shell) (GnomenuItem* self, gboolean value);
	const char* (*get_item_id) (GnomenuItem* self);
	void (*set_item_id) (GnomenuItem* self, const char* value);
	GnomenuItemType (*get_item_type) (GnomenuItem* self);
	void (*set_item_type) (GnomenuItem* self, GnomenuItemType value);
	gboolean (*get_item_use_underline) (GnomenuItem* self);
	void (*set_item_use_underline) (GnomenuItem* self, gboolean value);
	gboolean (*get_item_sensitive) (GnomenuItem* self);
	void (*set_item_sensitive) (GnomenuItem* self, gboolean value);
	gboolean (*get_item_visible) (GnomenuItem* self);
	void (*set_item_visible) (GnomenuItem* self, gboolean value);
	GnomenuItemState (*get_item_state) (GnomenuItem* self);
	void (*set_item_state) (GnomenuItem* self, GnomenuItemState value);
	const char* (*get_item_label) (GnomenuItem* self);
	void (*set_item_label) (GnomenuItem* self, const char* value);
	const char* (*get_item_icon) (GnomenuItem* self);
	void (*set_item_icon) (GnomenuItem* self, const char* value);
	const char* (*get_item_accel_text) (GnomenuItem* self);
	void (*set_item_accel_text) (GnomenuItem* self, const char* value);
	const char* (*get_item_font) (GnomenuItem* self);
	void (*set_item_font) (GnomenuItem* self, const char* value);
};

struct _GnomenuShellIface {
	GTypeInterface parent_iface;
	GnomenuItem* (*get_item) (GnomenuShell* self, gint position);
	GnomenuItem* (*get_item_by_id) (GnomenuShell* self, const char* id);
	gint (*get_item_position) (GnomenuShell* self, GnomenuItem* item);
	GnomenuItem* (*get_owner) (GnomenuShell* self);
	gint (*get_length) (GnomenuShell* self);
	void (*set_length) (GnomenuShell* self, gint value);
};

/**
 * convert the widget representation to xml representation.
 */
struct _GnomenuSerializer {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GnomenuSerializerPrivate * priv;
};

struct _GnomenuSerializerClass {
	GTypeClass parent_class;
	void (*finalize) (GnomenuSerializer *self);
};

struct _GnomenuMenu {
	GtkMenu parent_instance;
	GnomenuMenuPrivate * priv;
};

struct _GnomenuMenuClass {
	GtkMenuClass parent_class;
};

/**
 *
 * This structure is used to represent a 'background' passed from
 * the panel library.
 * 
 */
struct _GnomenuBackground {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GnomenuBackgroundPrivate * priv;
	GnomenuBackgroundType type;
	GdkPixmap* pixmap;
	GdkColor color;
	gint offset_x;
	gint offset_y;
};

struct _GnomenuBackgroundClass {
	GTypeClass parent_class;
	void (*finalize) (GnomenuBackground *self);
};

/**
 * A fancy menubar used by GlobalMenu.PanelApplet;
 * Not the same as Gtk.MenuBar, Gnomenu.MenuBar also
 * explicityly acts as the toplevel menubar of
 * its logical descents.
 *
 * It supports changing the background,
 * getting an xml representation of the overflown items,
 * changing the text gravity,
 * looking up item (and subitems) by path.
 */
struct _GnomenuMenuBar {
	GtkMenuBar parent_instance;
	GnomenuMenuBarPrivate * priv;
};

struct _GnomenuMenuBarClass {
	GtkMenuBarClass parent_class;
	void (*emit_activate) (GnomenuMenuBar* self, GnomenuMenuItem* item);
	void (*emit_select) (GnomenuMenuBar* self, GnomenuMenuItem* item);
	void (*emit_deselect) (GnomenuMenuBar* self, GnomenuMenuItem* item);
};

/**
 * fancy menu item used by GlobalMenu.PanelApplet
 *
 * Difference with Gtk.MenuItem:
 *
 * The various derived XXXMenuItem types are integrated
 * into Gnomenu.MenuItem to allow easier tranformation
 * from XML representation to Widgets.
 *
 * label and image are directly set on the MenuItem.
 * each item has an id,
 * associated with a position(after attached to a MenuShell)
 *
 * MenuItem also holds a back-reference to the toplevel 
 * menu bar. When an item is activated, the activated signal
 * on the menu bar is also invoked.
 * 
 */
struct _GnomenuMenuItem {
	GtkMenuItem parent_instance;
	GnomenuMenuItemPrivate * priv;
	GnomenuMenu* _submenu_cache;
};

struct _GnomenuMenuItemClass {
	GtkMenuItemClass parent_class;
};

/**
 * The Window widget extends Gtk.Window widget.
 *
 * The Window widget is capable of wrapping a Gdk.Window
 * or a is_foreign native window.
 *
 * It adds methods to bind any string as a property of
 * the underlining Gdk.Window.
 *
 * It emits property-notify-event signal when any properties of the underlineing Gdk.Window
 * has changed.
 *
 * As convenient wrappers,
 * it also addes the menu-context property and menu-event signal.
 *
 */
struct _GnomenuWindow {
	GObject parent_instance;
	GnomenuWindowPrivate * priv;
};

struct _GnomenuWindowClass {
	GObjectClass parent_class;
};

struct _GnomenuMenuBarBox {
	GtkContainer parent_instance;
	GnomenuMenuBarBoxPrivate * priv;
};

struct _GnomenuMenuBarBoxClass {
	GtkContainerClass parent_class;
};

struct _GnomenuMenuLabel {
	GtkContainer parent_instance;
	GnomenuMenuLabelPrivate * priv;
};

struct _GnomenuMenuLabelClass {
	GtkContainerClass parent_class;
};

struct _GnomenuGlobalMenu {
	GnomenuMenuBar parent_instance;
	GnomenuGlobalMenuPrivate * priv;
};

struct _GnomenuGlobalMenuClass {
	GnomenuMenuBarClass parent_class;
};

/******
 * The binary executable name is used as the key to link 
 * Wnck with GMenu.
 *
 * If the bin exec starts with wine, mono, python, use
 * the application's full name. (Although usually app and
 * dists don't agree on the same name!)
 *
 * the policy is sub-opt, because
 * one executable can actually be multiple applications,
 *
 * Example: NXClient Openoffice
 *
 * Known problem: Openoffice suite apps always show up 
 * as one Openoffice app (the last found one in GMenu).
 * */
struct _GnomenuApplication {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GnomenuApplicationPrivate * priv;
	GList* wnck_applications;
};

struct _GnomenuApplicationClass {
	GTypeClass parent_class;
	void (*finalize) (GnomenuApplication *self);
};

struct _GnomenuMonitor {
	GObject parent_instance;
	GnomenuMonitorPrivate * priv;
};

struct _GnomenuMonitorClass {
	GObjectClass parent_class;
};


GType gnomenu_background_type_get_type (void);
GType gnomenu_gravity_get_type (void);
double gnomenu_gravity_to_text_angle (GnomenuGravity g);
GtkArrowType gnomenu_gravity_to_arrow_type (GnomenuGravity g);
gpointer gnomenu_parser_ref (gpointer instance);
void gnomenu_parser_unref (gpointer instance);
GParamSpec* gnomenu_param_spec_parser (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void gnomenu_value_set_parser (GValue* value, gpointer v_object);
gpointer gnomenu_value_get_parser (const GValue* value);
GType gnomenu_parser_get_type (void);
GType gnomenu_item_type_get_type (void);
GType gnomenu_item_state_get_type (void);
GType gnomenu_item_get_type (void);
GType gnomenu_shell_get_type (void);
void gnomenu_parser_parse (GnomenuShell* shell, const char* description, GError** error);
gpointer gnomenu_serializer_ref (gpointer instance);
void gnomenu_serializer_unref (gpointer instance);
GParamSpec* gnomenu_param_spec_serializer (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void gnomenu_value_set_serializer (GValue* value, gpointer v_object);
gpointer gnomenu_value_get_serializer (const GValue* value);
GType gnomenu_serializer_get_type (void);
char* gnomenu_serializer_to_string (GObject* obj, gboolean pretty_print);
GnomenuItem* gnomenu_shell_get_item (GnomenuShell* self, gint position);
GnomenuItem* gnomenu_shell_get_item_by_id (GnomenuShell* self, const char* id);
gint gnomenu_shell_get_item_position (GnomenuShell* self, GnomenuItem* item);
GnomenuItem* gnomenu_shell_get_owner (GnomenuShell* self);
gint gnomenu_shell_get_length (GnomenuShell* self);
void gnomenu_shell_set_length (GnomenuShell* self, gint value);
GnomenuShell* gnomenu_shell_get_toplevel_shell (GnomenuShell* self);
gboolean gnomenu_item_is_child_of (GnomenuItem* self, GnomenuItem* possible_parent);
GnomenuItemState gnomenu_item_state_from_string (const char* str);
const char* gnomenu_item_state_to_string (GnomenuItemState state);
GnomenuItemType gnomenu_item_type_from_string (const char* str);
gboolean gnomenu_item_type_has_label (GnomenuItemType type);
const char* gnomenu_item_type_to_string (GnomenuItemType type);
GnomenuShell* gnomenu_item_get_shell (GnomenuItem* self);
GnomenuShell* gnomenu_item_get_sub_shell (GnomenuItem* self);
gboolean gnomenu_item_get_has_sub_shell (GnomenuItem* self);
void gnomenu_item_set_has_sub_shell (GnomenuItem* self, gboolean value);
gboolean gnomenu_item_get_client_side_sub_shell (GnomenuItem* self);
void gnomenu_item_set_client_side_sub_shell (GnomenuItem* self, gboolean value);
GnomenuShell* gnomenu_item_get_toplevel_shell (GnomenuItem* self);
gint gnomenu_item_get_item_position (GnomenuItem* self);
const char* gnomenu_item_get_item_id (GnomenuItem* self);
void gnomenu_item_set_item_id (GnomenuItem* self, const char* value);
GnomenuItemType gnomenu_item_get_item_type (GnomenuItem* self);
void gnomenu_item_set_item_type (GnomenuItem* self, GnomenuItemType value);
gboolean gnomenu_item_get_item_use_underline (GnomenuItem* self);
void gnomenu_item_set_item_use_underline (GnomenuItem* self, gboolean value);
gboolean gnomenu_item_get_item_sensitive (GnomenuItem* self);
void gnomenu_item_set_item_sensitive (GnomenuItem* self, gboolean value);
gboolean gnomenu_item_get_item_visible (GnomenuItem* self);
void gnomenu_item_set_item_visible (GnomenuItem* self, gboolean value);
GnomenuItemState gnomenu_item_get_item_state (GnomenuItem* self);
void gnomenu_item_set_item_state (GnomenuItem* self, GnomenuItemState value);
const char* gnomenu_item_get_item_label (GnomenuItem* self);
void gnomenu_item_set_item_label (GnomenuItem* self, const char* value);
const char* gnomenu_item_get_item_icon (GnomenuItem* self);
void gnomenu_item_set_item_icon (GnomenuItem* self, const char* value);
const char* gnomenu_item_get_item_accel_text (GnomenuItem* self);
void gnomenu_item_set_item_accel_text (GnomenuItem* self, const char* value);
const char* gnomenu_item_get_item_font (GnomenuItem* self);
void gnomenu_item_set_item_font (GnomenuItem* self, const char* value);
char* gnomenu_item_get_item_path_name (GnomenuItem* self);
char* gnomenu_item_get_item_path (GnomenuItem* self);
GType gnomenu_menu_get_type (void);
GnomenuMenu* gnomenu_menu_new (void);
GnomenuMenu* gnomenu_menu_construct (GType object_type);
gboolean gnomenu_menu_get_use_rgba_colormap (GnomenuMenu* self);
void gnomenu_menu_set_use_rgba_colormap (GnomenuMenu* self, gboolean value);
gpointer gnomenu_background_ref (gpointer instance);
void gnomenu_background_unref (gpointer instance);
GParamSpec* gnomenu_param_spec_background (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void gnomenu_value_set_background (GValue* value, gpointer v_object);
gpointer gnomenu_value_get_background (const GValue* value);
GType gnomenu_background_get_type (void);
GnomenuBackground* gnomenu_background_clone (GnomenuBackground* self);
GnomenuBackground* gnomenu_background_new (void);
GnomenuBackground* gnomenu_background_construct (GType object_type);
GType gnomenu_menu_bar_get_type (void);
GType gnomenu_menu_item_get_type (void);
GnomenuMenuBar* gnomenu_menu_bar_new (void);
GnomenuMenuBar* gnomenu_menu_bar_construct (GType object_type);
void gnomenu_menu_bar_emit_activate (GnomenuMenuBar* self, GnomenuMenuItem* item);
void gnomenu_menu_bar_emit_select (GnomenuMenuBar* self, GnomenuMenuItem* item);
void gnomenu_menu_bar_emit_deselect (GnomenuMenuBar* self, GnomenuMenuItem* item);
GnomenuMenuItem* gnomenu_menu_bar_get (GnomenuMenuBar* self, const char* path);
GnomenuBackground* gnomenu_menu_bar_get_background (GnomenuMenuBar* self);
void gnomenu_menu_bar_set_background (GnomenuMenuBar* self, GnomenuBackground* value);
GnomenuGravity gnomenu_menu_bar_get_gravity (GnomenuMenuBar* self);
void gnomenu_menu_bar_set_gravity (GnomenuMenuBar* self, GnomenuGravity value);
gboolean gnomenu_menu_bar_get_overflown (GnomenuMenuBar* self);
GnomenuMenuItem* gnomenu_menu_item_new (void);
GnomenuMenuItem* gnomenu_menu_item_construct (GType object_type);
GtkShadowType gnomenu_menu_item_item_state_to_shadow_type (GnomenuItemState state);
gint gnomenu_menu_item_get_max_width_chars (GnomenuMenuItem* self);
void gnomenu_menu_item_set_max_width_chars (GnomenuMenuItem* self, gint value);
GnomenuGravity gnomenu_menu_item_get_gravity (GnomenuMenuItem* self);
void gnomenu_menu_item_set_gravity (GnomenuMenuItem* self, GnomenuGravity value);
gboolean gnomenu_menu_item_get_truncated (GnomenuMenuItem* self);
void gnomenu_menu_item_set_truncated (GnomenuMenuItem* self, gboolean value);
GtkImage* gnomenu_menu_item_get_image (GnomenuMenuItem* self);
GType gnomenu_window_get_type (void);
GnomenuWindow* gnomenu_window_new (GdkWindow* window);
GnomenuWindow* gnomenu_window_construct (GType object_type, GdkWindow* window);
GnomenuWindow* gnomenu_window_foreign_new (gulong xid);
void gnomenu_window_set_key_widget (GnomenuWindow* self, GtkWidget* widget);
char* gnomenu_window_get (GnomenuWindow* self, const char* property_name);
void gnomenu_window_set (GnomenuWindow* self, const char* property_name, const char* value);
char* gnomenu_window_get_by_atom (GnomenuWindow* self, GdkAtom atom);
void gnomenu_window_set_by_atom (GnomenuWindow* self, GdkAtom atom, const char* value);
void gnomenu_window_emit_menu_event (GnomenuWindow* self, const char* path);
void gnomenu_window_emit_menu_select (GnomenuWindow* self, const char* path, const char* pos);
void gnomenu_window_emit_menu_deselect (GnomenuWindow* self, const char* path);
gboolean gnomenu_window_grab_key (GnomenuWindow* self, guint keyval, GdkModifierType state);
gboolean gnomenu_window_ungrab_key (GnomenuWindow* self, guint keyval, GdkModifierType state);
GdkWindow* gnomenu_window_get_window (GnomenuWindow* self);
void gnomenu_window_set_window (GnomenuWindow* self, GdkWindow* value);
const char* gnomenu_window_get_menu_context (GnomenuWindow* self);
void gnomenu_window_set_menu_context (GnomenuWindow* self, const char* value);
GType gnomenu_menu_bar_box_get_type (void);
GnomenuMenuBarBox* gnomenu_menu_bar_box_new (void);
GnomenuMenuBarBox* gnomenu_menu_bar_box_construct (GType object_type);
gint* gnomenu_menu_bar_box_get_size_hints (GnomenuMenuBarBox* self, int* result_length1);
GtkPackDirection gnomenu_menu_bar_box_get_pack_direction (GnomenuMenuBarBox* self);
void gnomenu_menu_bar_box_set_pack_direction (GnomenuMenuBarBox* self, GtkPackDirection value);
GtkPackDirection gnomenu_menu_bar_box_get_child_pack_direction (GnomenuMenuBarBox* self);
void gnomenu_menu_bar_box_set_child_pack_direction (GnomenuMenuBarBox* self, GtkPackDirection value);
GnomenuGravity gnomenu_menu_bar_box_get_gravity (GnomenuMenuBarBox* self);
void gnomenu_menu_bar_box_set_gravity (GnomenuMenuBarBox* self, GnomenuGravity value);
void gnomenu_menu_bar_box_set_background (GnomenuMenuBarBox* self, GnomenuBackground* value);
GtkMenuItem* gtk_menu_shell_get_item (GtkMenuShell* menu_shell, gint position);
void gtk_menu_shell_truncate (GtkMenuShell* menushell, gint length);
gint gtk_menu_shell_length_without_truncated (GtkMenuShell* menu_shell);
gint gtk_menu_shell_get_item_position (GtkMenuShell* menu_shell, GtkMenuItem* item);
GType gnomenu_menu_label_get_type (void);
GnomenuMenuLabel* gnomenu_menu_label_new (void);
GnomenuMenuLabel* gnomenu_menu_label_construct (GType object_type);
const char* gnomenu_menu_label_get_accel (GnomenuMenuLabel* self);
void gnomenu_menu_label_set_accel (GnomenuMenuLabel* self, const char* value);
gboolean gnomenu_menu_label_get_use_underline (GnomenuMenuLabel* self);
void gnomenu_menu_label_set_use_underline (GnomenuMenuLabel* self, gboolean value);
gint gnomenu_menu_label_get_max_width_chars (GnomenuMenuLabel* self);
void gnomenu_menu_label_set_max_width_chars (GnomenuMenuLabel* self, gint value);
const char* gnomenu_menu_label_get_label (GnomenuMenuLabel* self);
void gnomenu_menu_label_set_label (GnomenuMenuLabel* self, const char* value);
GnomenuGravity gnomenu_menu_label_get_gravity (GnomenuMenuLabel* self);
void gnomenu_menu_label_set_gravity (GnomenuMenuLabel* self, GnomenuGravity value);
GtkLabel* gnomenu_menu_label_get_label_widget (GnomenuMenuLabel* self);
guint gnomenu_menu_label_get_mnemonic_keyval (GnomenuMenuLabel* self);
gboolean gnomenu_grab_key (GdkWindow* grab_window, guint keyval, GdkModifierType state);
gboolean gnomenu_ungrab_key (GdkWindow* grab_window, guint keyval, GdkModifierType state);
GType gnomenu_global_menu_get_type (void);
void gnomenu_global_menu_switch_to (GnomenuGlobalMenu* self, gulong xid);
GnomenuGlobalMenu* gnomenu_global_menu_new (void);
GnomenuGlobalMenu* gnomenu_global_menu_construct (GType object_type);
#define GNOMENU_NET_GLOBALMENU_MENU_CONTEXT "_NET_GLOBALMENU_MENU_CONTEXT"
#define GNOMENU_NET_GLOBALMENU_MENU_EVENT "_NET_GLOBALMENU_MENU_EVENT"
#define GNOMENU_NET_GLOBALMENU_MENU_SELECT "_NET_GLOBALMENU_MENU_SELECT"
#define GNOMENU_NET_GLOBALMENU_MENU_DESELECT "_NET_GLOBALMENU_MENU_DESELECT"
gpointer gnomenu_application_ref (gpointer instance);
void gnomenu_application_unref (gpointer instance);
GParamSpec* gnomenu_param_spec_application (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void gnomenu_value_set_application (GValue* value, gpointer v_object);
gpointer gnomenu_value_get_application (const GValue* value);
GType gnomenu_application_get_type (void);
extern GList* gnomenu_application_applications;
extern GHashTable* gnomenu_application_dict;
void gnomenu_application_init (void);
GnomenuApplication* gnomenu_application_add_application (const char* key);
GnomenuApplication* gnomenu_application_lookup (const char* key);
GnomenuApplication* gnomenu_application_lookup_from_wnck (WnckApplication* wapp);
void gnomenu_application_update (GnomenuApplication* self);
char* get_task_name_by_pid (gint pid);
const char* gnomenu_application_get_readable_name (GnomenuApplication* self);
const char* gnomenu_application_get_exec_path (GnomenuApplication* self);
const char* gnomenu_application_get_icon_name (GnomenuApplication* self);
GdkPixbuf* gnomenu_application_get_icon_pixbuf (GnomenuApplication* self);
gboolean gnomenu_application_get_not_in_menu (GnomenuApplication* self);
GtkWidget* gnomenu_application_get_proxy_item (GnomenuApplication* self);
GType gnomenu_monitor_get_type (void);
GnomenuMonitor* gnomenu_monitor_new (void);
GnomenuMonitor* gnomenu_monitor_construct (GType object_type);
GdkScreen* gnomenu_monitor_get_screen (GnomenuMonitor* self);
void gnomenu_monitor_set_screen (GnomenuMonitor* self, GdkScreen* value);
gulong gnomenu_monitor_get_current_xid (GnomenuMonitor* self);


G_END_DECLS

#endif
