
#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>


#define GNOMENU_TYPE_SHELL (gnomenu_shell_get_type ())
#define GNOMENU_SHELL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNOMENU_TYPE_SHELL, GnomenuShell))
#define GNOMENU_IS_SHELL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNOMENU_TYPE_SHELL))
#define GNOMENU_SHELL_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GNOMENU_TYPE_SHELL, GnomenuShellIface))

typedef struct _GnomenuShell GnomenuShell;
typedef struct _GnomenuShellIface GnomenuShellIface;

#define GNOMENU_TYPE_ITEM (gnomenu_item_get_type ())
#define GNOMENU_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNOMENU_TYPE_ITEM, GnomenuItem))
#define GNOMENU_IS_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNOMENU_TYPE_ITEM))
#define GNOMENU_ITEM_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GNOMENU_TYPE_ITEM, GnomenuItemIface))

typedef struct _GnomenuItem GnomenuItem;
typedef struct _GnomenuItemIface GnomenuItemIface;

#define GNOMENU_TYPE_ITEM_TYPE (gnomenu_item_type_get_type ())

#define GNOMENU_TYPE_ITEM_STATE (gnomenu_item_state_get_type ())

#define GNOMENU_TYPE_MENU (gnomenu_menu_get_type ())
#define GNOMENU_MENU(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNOMENU_TYPE_MENU, GnomenuMenu))
#define GNOMENU_MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNOMENU_TYPE_MENU, GnomenuMenuClass))
#define GNOMENU_IS_MENU(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNOMENU_TYPE_MENU))
#define GNOMENU_IS_MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNOMENU_TYPE_MENU))
#define GNOMENU_MENU_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNOMENU_TYPE_MENU, GnomenuMenuClass))

typedef struct _GnomenuMenu GnomenuMenu;
typedef struct _GnomenuMenuClass GnomenuMenuClass;
typedef struct _GnomenuMenuPrivate GnomenuMenuPrivate;

#define GNOMENU_TYPE_MENU_ITEM (gnomenu_menu_item_get_type ())
#define GNOMENU_MENU_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNOMENU_TYPE_MENU_ITEM, GnomenuMenuItem))
#define GNOMENU_MENU_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNOMENU_TYPE_MENU_ITEM, GnomenuMenuItemClass))
#define GNOMENU_IS_MENU_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNOMENU_TYPE_MENU_ITEM))
#define GNOMENU_IS_MENU_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNOMENU_TYPE_MENU_ITEM))
#define GNOMENU_MENU_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNOMENU_TYPE_MENU_ITEM, GnomenuMenuItemClass))

typedef struct _GnomenuMenuItem GnomenuMenuItem;
typedef struct _GnomenuMenuItemClass GnomenuMenuItemClass;

typedef enum  {
	GNOMENU_ITEM_TYPE_NORMAL = 0,
	GNOMENU_ITEM_TYPE_CHECK = 1,
	GNOMENU_ITEM_TYPE_RADIO = 2,
	GNOMENU_ITEM_TYPE_IMAGE = 3,
	GNOMENU_ITEM_TYPE_SEPARATOR = 4,
	GNOMENU_ITEM_TYPE_ARROW = 5,
	GNOMENU_ITEM_TYPE_ICON = 6
} GnomenuItemType;

typedef enum  {
	GNOMENU_ITEM_STATE_UNTOGGLED = 0,
	GNOMENU_ITEM_STATE_TOGGLED = 1,
	GNOMENU_ITEM_STATE_TRISTATE = 2
} GnomenuItemState;

struct _GnomenuItemIface {
	GTypeInterface parent_iface;
	GnomenuShell* (*get_shell) (GnomenuItem* self);
	GnomenuShell* (*get_sub_shell) (GnomenuItem* self);
	gboolean (*get_has_sub_shell) (GnomenuItem* self);
	void (*set_has_sub_shell) (GnomenuItem* self, gboolean value);
	gboolean (*get_client_side_sub_shell) (GnomenuItem* self);
	void (*set_client_side_sub_shell) (GnomenuItem* self, gboolean value);
	const char* (*get_item_id) (GnomenuItem* self);
	void (*set_item_id) (GnomenuItem* self, const char* value);
	GnomenuItemType (*get_item_type) (GnomenuItem* self);
	void (*set_item_type) (GnomenuItem* self, GnomenuItemType value);
	gboolean (*get_item_use_underline) (GnomenuItem* self);
	void (*set_item_use_underline) (GnomenuItem* self, gboolean value);
	gboolean (*get_item_sensitive) (GnomenuItem* self);
	void (*set_item_sensitive) (GnomenuItem* self, gboolean value);
	gboolean (*get_item_visible) (GnomenuItem* self);
	void (*set_item_visible) (GnomenuItem* self, gboolean value);
	GnomenuItemState (*get_item_state) (GnomenuItem* self);
	void (*set_item_state) (GnomenuItem* self, GnomenuItemState value);
	const char* (*get_item_label) (GnomenuItem* self);
	void (*set_item_label) (GnomenuItem* self, const char* value);
	const char* (*get_item_icon) (GnomenuItem* self);
	void (*set_item_icon) (GnomenuItem* self, const char* value);
	const char* (*get_item_accel_text) (GnomenuItem* self);
	void (*set_item_accel_text) (GnomenuItem* self, const char* value);
	const char* (*get_item_font) (GnomenuItem* self);
	void (*set_item_font) (GnomenuItem* self, const char* value);
};

struct _GnomenuShellIface {
	GTypeInterface parent_iface;
	GnomenuItem* (*get_item) (GnomenuShell* self, gint position);
	GnomenuItem* (*get_item_by_id) (GnomenuShell* self, const char* id);
	gint (*get_item_position) (GnomenuShell* self, GnomenuItem* item);
	GnomenuItem* (*get_owner) (GnomenuShell* self);
	gint (*get_length) (GnomenuShell* self);
	void (*set_length) (GnomenuShell* self, gint value);
};

struct _GnomenuMenu {
	GtkMenu parent_instance;
	GnomenuMenuPrivate * priv;
};

struct _GnomenuMenuClass {
	GtkMenuClass parent_class;
};

struct _GnomenuMenuPrivate {
	gboolean disposed;
	gboolean _use_rgba_colormap;
};



GType gnomenu_item_type_get_type (void);
GType gnomenu_item_state_get_type (void);
GType gnomenu_item_get_type (void);
GType gnomenu_shell_get_type (void);
GType gnomenu_menu_get_type (void);
#define GNOMENU_MENU_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GNOMENU_TYPE_MENU, GnomenuMenuPrivate))
enum  {
	GNOMENU_MENU_DUMMY_PROPERTY,
	GNOMENU_MENU_USE_RGBA_COLORMAP,
	GNOMENU_MENU_OWNER,
	GNOMENU_MENU_LENGTH
};
GnomenuMenu* gnomenu_menu_new (void);
GnomenuMenu* gnomenu_menu_construct (GType object_type);
GnomenuMenu* gnomenu_menu_new (void);
static void gnomenu_menu_real_dispose (GObject* base);
GtkMenuItem* gtk_menu_shell_get_item (GtkMenuShell* menu_shell, gint position);
static GnomenuItem* gnomenu_menu_real_get_item (GnomenuShell* base, gint position);
const char* gnomenu_item_get_item_id (GnomenuItem* self);
static GnomenuItem* gnomenu_menu_real_get_item_by_id (GnomenuShell* base, const char* id);
gint gtk_menu_shell_get_item_position (GtkMenuShell* menu_shell, GtkMenuItem* item);
static gint gnomenu_menu_real_get_item_position (GnomenuShell* base, GnomenuItem* item);
gboolean gnomenu_menu_get_use_rgba_colormap (GnomenuMenu* self);
void gnomenu_menu_set_use_rgba_colormap (GnomenuMenu* self, gboolean value);
gint gtk_menu_shell_length_without_truncated (GtkMenuShell* menu_shell);
void gtk_menu_shell_truncate (GtkMenuShell* menushell, gint length);
static GObject * gnomenu_menu_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
GType gnomenu_menu_item_get_type (void);
static gpointer gnomenu_menu_parent_class = NULL;
static GnomenuShellIface* gnomenu_menu_gnomenu_shell_parent_iface = NULL;
static void gnomenu_menu_finalize (GObject* obj);
static void gnomenu_menu_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void gnomenu_menu_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static int _vala_strcmp0 (const char * str1, const char * str2);



GnomenuMenu* gnomenu_menu_construct (GType object_type) {
	GnomenuMenu * self;
	self = g_object_newv (object_type, 0, NULL);
	return self;
}


GnomenuMenu* gnomenu_menu_new (void) {
	return gnomenu_menu_construct (GNOMENU_TYPE_MENU);
}


/*
 * We don't do dispose, but gtk won't reset these pointers
 * related to the colormaps and valgrind won't be happy.
 */
static void gnomenu_menu_real_dispose (GObject* base) {
	GnomenuMenu * self;
	self = (GnomenuMenu*) base;
	if (!self->priv->disposed) {
		self->priv->disposed = TRUE;
	}
	G_OBJECT_CLASS (gnomenu_menu_parent_class)->dispose ((GObject*) GTK_MENU (self));
}


static GnomenuItem* gnomenu_menu_real_get_item (GnomenuShell* base, gint position) {
	GnomenuMenu * self;
	GnomenuItem* _tmp1_;
	GtkMenuItem* _tmp0_;
	self = (GnomenuMenu*) base;
	_tmp1_ = NULL;
	_tmp0_ = NULL;
	return (_tmp1_ = (_tmp0_ = gtk_menu_shell_get_item (self, position), GNOMENU_IS_ITEM (_tmp0_) ? ((GnomenuItem*) _tmp0_) : NULL), (_tmp1_ == NULL) ? NULL : g_object_ref (_tmp1_));
}


static GnomenuItem* gnomenu_menu_real_get_item_by_id (GnomenuShell* base, const char* id) {
	GnomenuMenu * self;
	self = (GnomenuMenu*) base;
	g_return_val_if_fail (id != NULL, NULL);
	{
		GList* child_collection;
		GList* child_it;
		child_collection = gtk_container_get_children ((GtkContainer*) self);
		for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
			GtkWidget* child;
			child = (GtkWidget*) child_it->data;
			{
				GnomenuItem* _tmp1_;
				GtkWidget* _tmp0_;
				GnomenuItem* item;
				_tmp1_ = NULL;
				_tmp0_ = NULL;
				item = (_tmp1_ = (_tmp0_ = child, GNOMENU_IS_ITEM (_tmp0_) ? ((GnomenuItem*) _tmp0_) : NULL), (_tmp1_ == NULL) ? NULL : g_object_ref (_tmp1_));
				if (_vala_strcmp0 (gnomenu_item_get_item_id (item), id) == 0) {
					GnomenuItem* _tmp2_;
					_tmp2_ = NULL;
					return (_tmp2_ = item, (child_collection == NULL) ? NULL : (child_collection = (g_list_free (child_collection), NULL)), _tmp2_);
				}
				(item == NULL) ? NULL : (item = (g_object_unref (item), NULL));
			}
		}
		(child_collection == NULL) ? NULL : (child_collection = (g_list_free (child_collection), NULL));
	}
	return NULL;
}


static gint gnomenu_menu_real_get_item_position (GnomenuShell* base, GnomenuItem* item) {
	GnomenuMenu * self;
	GnomenuItem* _tmp0_;
	self = (GnomenuMenu*) base;
	g_return_val_if_fail (item != NULL, 0);
	_tmp0_ = NULL;
	return gtk_menu_shell_get_item_position (self, (_tmp0_ = item, GNOMENU_IS_MENU_ITEM (_tmp0_) ? ((GnomenuMenuItem*) _tmp0_) : NULL));
}


gboolean gnomenu_menu_get_use_rgba_colormap (GnomenuMenu* self) {
	g_return_val_if_fail (self != NULL, FALSE);
	return self->priv->_use_rgba_colormap;
}


void gnomenu_menu_set_use_rgba_colormap (GnomenuMenu* self, gboolean value) {
	GdkScreen* _tmp1_;
	GdkScreen* screen;
	GdkColormap* _tmp2_;
	GdkColormap* colormap;
	g_return_if_fail (self != NULL);
	if (self->priv->_use_rgba_colormap == value) {
		return;
	}
	self->priv->_use_rgba_colormap = value;
	_tmp1_ = NULL;
	screen = (_tmp1_ = gtk_widget_get_screen (((GtkMenu*) self)->toplevel), (_tmp1_ == NULL) ? NULL : g_object_ref (_tmp1_));
	_tmp2_ = NULL;
	colormap = (_tmp2_ = gdk_screen_get_rgba_colormap (screen), (_tmp2_ == NULL) ? NULL : g_object_ref (_tmp2_));
	if (colormap != NULL) {
		gtk_widget_set_colormap (((GtkMenu*) self)->toplevel, colormap);
		gtk_widget_set_colormap ((GtkWidget*) self, colormap);
	}
	(screen == NULL) ? NULL : (screen = (g_object_unref (screen), NULL));
	(colormap == NULL) ? NULL : (colormap = (g_object_unref (colormap), NULL));
	g_object_notify ((GObject *) self, "use-rgba-colormap");
}


static GnomenuItem* gnomenu_menu_real_get_owner (GnomenuShell* base) {
	GnomenuMenu* self;
	GtkWidget* _tmp0_;
	self = (GnomenuMenu*) base;
	_tmp0_ = NULL;
	return (_tmp0_ = gtk_menu_get_attach_widget ((GtkMenu*) self), GNOMENU_IS_ITEM (_tmp0_) ? ((GnomenuItem*) _tmp0_) : NULL);
}


static gint gnomenu_menu_real_get_length (GnomenuShell* base) {
	GnomenuMenu* self;
	self = (GnomenuMenu*) base;
	return gtk_menu_shell_length_without_truncated (self);
}


static void gnomenu_menu_real_set_length (GnomenuShell* base, gint value) {
	GnomenuMenu* self;
	self = (GnomenuMenu*) base;
	gtk_menu_shell_truncate (self, value);
	g_object_notify ((GObject *) self, "length");
}


static GObject * gnomenu_menu_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GnomenuMenuClass * klass;
	GObjectClass * parent_class;
	GnomenuMenu * self;
	klass = GNOMENU_MENU_CLASS (g_type_class_peek (GNOMENU_TYPE_MENU));
	parent_class = G_OBJECT_CLASS (g_type_class_peek_parent (klass));
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = GNOMENU_MENU (obj);
	{
		const char* rgba;
		rgba = g_getenv ("LIBGNOMENU_ENABLE_RGBA");
		gnomenu_menu_set_use_rgba_colormap (self, rgba != NULL);
	}
	return obj;
}


static void gnomenu_menu_class_init (GnomenuMenuClass * klass) {
	gnomenu_menu_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GnomenuMenuPrivate));
	G_OBJECT_CLASS (klass)->dispose = gnomenu_menu_real_dispose;
	G_OBJECT_CLASS (klass)->get_property = gnomenu_menu_get_property;
	G_OBJECT_CLASS (klass)->set_property = gnomenu_menu_set_property;
	G_OBJECT_CLASS (klass)->constructor = gnomenu_menu_constructor;
	G_OBJECT_CLASS (klass)->finalize = gnomenu_menu_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNOMENU_MENU_USE_RGBA_COLORMAP, g_param_spec_boolean ("use-rgba-colormap", "use-rgba-colormap", "use-rgba-colormap", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_override_property (G_OBJECT_CLASS (klass), GNOMENU_MENU_OWNER, "owner");
	g_object_class_override_property (G_OBJECT_CLASS (klass), GNOMENU_MENU_LENGTH, "length");
	{
		GnomenuMenuItem* _include_menu_item_definiation;
		_include_menu_item_definiation = NULL;
		(_include_menu_item_definiation == NULL) ? NULL : (_include_menu_item_definiation = (g_object_unref (_include_menu_item_definiation), NULL));
	}
}


static void gnomenu_menu_gnomenu_shell_interface_init (GnomenuShellIface * iface) {
	gnomenu_menu_gnomenu_shell_parent_iface = g_type_interface_peek_parent (iface);
	iface->get_item = gnomenu_menu_real_get_item;
	iface->get_item_by_id = gnomenu_menu_real_get_item_by_id;
	iface->get_item_position = gnomenu_menu_real_get_item_position;
	iface->get_owner = gnomenu_menu_real_get_owner;
	iface->get_length = gnomenu_menu_real_get_length;
	iface->set_length = gnomenu_menu_real_set_length;
}


static void gnomenu_menu_instance_init (GnomenuMenu * self) {
	self->priv = GNOMENU_MENU_GET_PRIVATE (self);
	self->priv->disposed = FALSE;
	self->priv->_use_rgba_colormap = FALSE;
}


static void gnomenu_menu_finalize (GObject* obj) {
	GnomenuMenu * self;
	self = GNOMENU_MENU (obj);
	G_OBJECT_CLASS (gnomenu_menu_parent_class)->finalize (obj);
}


GType gnomenu_menu_get_type (void) {
	static GType gnomenu_menu_type_id = 0;
	if (gnomenu_menu_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (GnomenuMenuClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gnomenu_menu_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GnomenuMenu), 0, (GInstanceInitFunc) gnomenu_menu_instance_init, NULL };
		static const GInterfaceInfo gnomenu_shell_info = { (GInterfaceInitFunc) gnomenu_menu_gnomenu_shell_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		gnomenu_menu_type_id = g_type_register_static (GTK_TYPE_MENU, "GnomenuMenu", &g_define_type_info, 0);
		g_type_add_interface_static (gnomenu_menu_type_id, GNOMENU_TYPE_SHELL, &gnomenu_shell_info);
	}
	return gnomenu_menu_type_id;
}


static void gnomenu_menu_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	GnomenuMenu * self;
	gpointer boxed;
	self = GNOMENU_MENU (object);
	switch (property_id) {
		case GNOMENU_MENU_USE_RGBA_COLORMAP:
		g_value_set_boolean (value, gnomenu_menu_get_use_rgba_colormap (self));
		break;
		case GNOMENU_MENU_OWNER:
		g_value_set_object (value, gnomenu_shell_get_owner ((GnomenuShell*) self));
		break;
		case GNOMENU_MENU_LENGTH:
		g_value_set_int (value, gnomenu_shell_get_length ((GnomenuShell*) self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void gnomenu_menu_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	GnomenuMenu * self;
	self = GNOMENU_MENU (object);
	switch (property_id) {
		case GNOMENU_MENU_USE_RGBA_COLORMAP:
		gnomenu_menu_set_use_rgba_colormap (self, g_value_get_boolean (value));
		break;
		case GNOMENU_MENU_LENGTH:
		gnomenu_shell_set_length ((GnomenuShell*) self, g_value_get_int (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}




