
#include <glib.h>
#include <glib-object.h>
#include <gdk/gdk.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <cairo.h>
#include <gobject/gvaluecollector.h>


#define GNOMENU_TYPE_BACKGROUND (gnomenu_background_get_type ())
#define GNOMENU_BACKGROUND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNOMENU_TYPE_BACKGROUND, GnomenuBackground))
#define GNOMENU_BACKGROUND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNOMENU_TYPE_BACKGROUND, GnomenuBackgroundClass))
#define GNOMENU_IS_BACKGROUND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNOMENU_TYPE_BACKGROUND))
#define GNOMENU_IS_BACKGROUND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNOMENU_TYPE_BACKGROUND))
#define GNOMENU_BACKGROUND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNOMENU_TYPE_BACKGROUND, GnomenuBackgroundClass))

typedef struct _GnomenuBackground GnomenuBackground;
typedef struct _GnomenuBackgroundClass GnomenuBackgroundClass;
typedef struct _GnomenuBackgroundPrivate GnomenuBackgroundPrivate;

#define GNOMENU_TYPE_BACKGROUND_TYPE (gnomenu_background_type_get_type ())
typedef struct _GnomenuParamSpecBackground GnomenuParamSpecBackground;

#define GNOMENU_TYPE_SHELL (gnomenu_shell_get_type ())
#define GNOMENU_SHELL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNOMENU_TYPE_SHELL, GnomenuShell))
#define GNOMENU_IS_SHELL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNOMENU_TYPE_SHELL))
#define GNOMENU_SHELL_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GNOMENU_TYPE_SHELL, GnomenuShellIface))

typedef struct _GnomenuShell GnomenuShell;
typedef struct _GnomenuShellIface GnomenuShellIface;

#define GNOMENU_TYPE_ITEM (gnomenu_item_get_type ())
#define GNOMENU_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNOMENU_TYPE_ITEM, GnomenuItem))
#define GNOMENU_IS_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNOMENU_TYPE_ITEM))
#define GNOMENU_ITEM_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GNOMENU_TYPE_ITEM, GnomenuItemIface))

typedef struct _GnomenuItem GnomenuItem;
typedef struct _GnomenuItemIface GnomenuItemIface;

#define GNOMENU_TYPE_ITEM_TYPE (gnomenu_item_type_get_type ())

#define GNOMENU_TYPE_ITEM_STATE (gnomenu_item_state_get_type ())

#define GNOMENU_TYPE_MENU_BAR (gnomenu_menu_bar_get_type ())
#define GNOMENU_MENU_BAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNOMENU_TYPE_MENU_BAR, GnomenuMenuBar))
#define GNOMENU_MENU_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNOMENU_TYPE_MENU_BAR, GnomenuMenuBarClass))
#define GNOMENU_IS_MENU_BAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNOMENU_TYPE_MENU_BAR))
#define GNOMENU_IS_MENU_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNOMENU_TYPE_MENU_BAR))
#define GNOMENU_MENU_BAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNOMENU_TYPE_MENU_BAR, GnomenuMenuBarClass))

typedef struct _GnomenuMenuBar GnomenuMenuBar;
typedef struct _GnomenuMenuBarClass GnomenuMenuBarClass;
typedef struct _GnomenuMenuBarPrivate GnomenuMenuBarPrivate;

#define GNOMENU_TYPE_MENU_ITEM (gnomenu_menu_item_get_type ())
#define GNOMENU_MENU_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNOMENU_TYPE_MENU_ITEM, GnomenuMenuItem))
#define GNOMENU_MENU_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNOMENU_TYPE_MENU_ITEM, GnomenuMenuItemClass))
#define GNOMENU_IS_MENU_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNOMENU_TYPE_MENU_ITEM))
#define GNOMENU_IS_MENU_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNOMENU_TYPE_MENU_ITEM))
#define GNOMENU_MENU_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNOMENU_TYPE_MENU_ITEM, GnomenuMenuItemClass))

typedef struct _GnomenuMenuItem GnomenuMenuItem;
typedef struct _GnomenuMenuItemClass GnomenuMenuItemClass;

#define GNOMENU_TYPE_GRAVITY (gnomenu_gravity_get_type ())

typedef enum  {
	GNOMENU_BACKGROUND_TYPE_NONE = 0,
	GNOMENU_BACKGROUND_TYPE_COLOR = 1,
	GNOMENU_BACKGROUND_TYPE_PIXMAP = 2
} GnomenuBackgroundType;

/**
 *
 * This structure is used to represent a 'background' passed from
 * the panel library.
 * 
 */
struct _GnomenuBackground {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GnomenuBackgroundPrivate * priv;
	GnomenuBackgroundType type;
	GdkPixmap* pixmap;
	GdkColor color;
	gint offset_x;
	gint offset_y;
};

struct _GnomenuBackgroundClass {
	GTypeClass parent_class;
	void (*finalize) (GnomenuBackground *self);
};

struct _GnomenuParamSpecBackground {
	GParamSpec parent_instance;
};

typedef enum  {
	GNOMENU_ITEM_TYPE_NORMAL = 0,
	GNOMENU_ITEM_TYPE_CHECK = 1,
	GNOMENU_ITEM_TYPE_RADIO = 2,
	GNOMENU_ITEM_TYPE_IMAGE = 3,
	GNOMENU_ITEM_TYPE_SEPARATOR = 4,
	GNOMENU_ITEM_TYPE_ARROW = 5,
	GNOMENU_ITEM_TYPE_ICON = 6
} GnomenuItemType;

typedef enum  {
	GNOMENU_ITEM_STATE_UNTOGGLED = 0,
	GNOMENU_ITEM_STATE_TOGGLED = 1,
	GNOMENU_ITEM_STATE_TRISTATE = 2
} GnomenuItemState;

struct _GnomenuItemIface {
	GTypeInterface parent_iface;
	GnomenuShell* (*get_shell) (GnomenuItem* self);
	GnomenuShell* (*get_sub_shell) (GnomenuItem* self);
	gboolean (*get_has_sub_shell) (GnomenuItem* self);
	void (*set_has_sub_shell) (GnomenuItem* self, gboolean value);
	gboolean (*get_client_side_sub_shell) (GnomenuItem* self);
	void (*set_client_side_sub_shell) (GnomenuItem* self, gboolean value);
	const char* (*get_item_id) (GnomenuItem* self);
	void (*set_item_id) (GnomenuItem* self, const char* value);
	GnomenuItemType (*get_item_type) (GnomenuItem* self);
	void (*set_item_type) (GnomenuItem* self, GnomenuItemType value);
	gboolean (*get_item_use_underline) (GnomenuItem* self);
	void (*set_item_use_underline) (GnomenuItem* self, gboolean value);
	gboolean (*get_item_sensitive) (GnomenuItem* self);
	void (*set_item_sensitive) (GnomenuItem* self, gboolean value);
	gboolean (*get_item_visible) (GnomenuItem* self);
	void (*set_item_visible) (GnomenuItem* self, gboolean value);
	GnomenuItemState (*get_item_state) (GnomenuItem* self);
	void (*set_item_state) (GnomenuItem* self, GnomenuItemState value);
	const char* (*get_item_label) (GnomenuItem* self);
	void (*set_item_label) (GnomenuItem* self, const char* value);
	const char* (*get_item_icon) (GnomenuItem* self);
	void (*set_item_icon) (GnomenuItem* self, const char* value);
	const char* (*get_item_accel_text) (GnomenuItem* self);
	void (*set_item_accel_text) (GnomenuItem* self, const char* value);
	const char* (*get_item_font) (GnomenuItem* self);
	void (*set_item_font) (GnomenuItem* self, const char* value);
};

struct _GnomenuShellIface {
	GTypeInterface parent_iface;
	GnomenuItem* (*get_item) (GnomenuShell* self, gint position);
	GnomenuItem* (*get_item_by_id) (GnomenuShell* self, const char* id);
	gint (*get_item_position) (GnomenuShell* self, GnomenuItem* item);
	GnomenuItem* (*get_owner) (GnomenuShell* self);
	gint (*get_length) (GnomenuShell* self);
	void (*set_length) (GnomenuShell* self, gint value);
};

/**
 * A fancy menubar used by GlobalMenu.PanelApplet;
 * Not the same as Gtk.MenuBar, Gnomenu.MenuBar also
 * explicityly acts as the toplevel menubar of
 * its logical descents.
 *
 * It supports changing the background,
 * getting an xml representation of the overflown items,
 * changing the text gravity,
 * looking up item (and subitems) by path.
 */
struct _GnomenuMenuBar {
	GtkMenuBar parent_instance;
	GnomenuMenuBarPrivate * priv;
};

struct _GnomenuMenuBarClass {
	GtkMenuBarClass parent_class;
	void (*emit_activate) (GnomenuMenuBar* self, GnomenuMenuItem* item);
	void (*emit_select) (GnomenuMenuBar* self, GnomenuMenuItem* item);
	void (*emit_deselect) (GnomenuMenuBar* self, GnomenuMenuItem* item);
};

typedef enum  {
	GNOMENU_GRAVITY_DOWN = 0,
	GNOMENU_GRAVITY_UP = 1,
	GNOMENU_GRAVITY_LEFT = 2,
	GNOMENU_GRAVITY_RIGHT = 3
} GnomenuGravity;

struct _GnomenuMenuBarPrivate {
	GnomenuBackground* _background;
	GnomenuGravity _gravity;
	GnomenuMenuItem* _overflown_item;
	gboolean disposed;
};



gpointer gnomenu_background_ref (gpointer instance);
void gnomenu_background_unref (gpointer instance);
GParamSpec* gnomenu_param_spec_background (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void gnomenu_value_set_background (GValue* value, gpointer v_object);
gpointer gnomenu_value_get_background (const GValue* value);
GType gnomenu_background_get_type (void);
GType gnomenu_background_type_get_type (void);
enum  {
	GNOMENU_BACKGROUND_DUMMY_PROPERTY
};
GnomenuBackground* gnomenu_background_new (void);
GnomenuBackground* gnomenu_background_construct (GType object_type);
GnomenuBackground* gnomenu_background_clone (GnomenuBackground* self);
GnomenuBackground* gnomenu_background_new (void);
static gpointer gnomenu_background_parent_class = NULL;
static void gnomenu_background_finalize (GnomenuBackground* obj);
GType gnomenu_item_type_get_type (void);
GType gnomenu_item_state_get_type (void);
GType gnomenu_item_get_type (void);
GType gnomenu_shell_get_type (void);
GType gnomenu_menu_bar_get_type (void);
GType gnomenu_menu_item_get_type (void);
GType gnomenu_gravity_get_type (void);
#define GNOMENU_MENU_BAR_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GNOMENU_TYPE_MENU_BAR, GnomenuMenuBarPrivate))
enum  {
	GNOMENU_MENU_BAR_DUMMY_PROPERTY,
	GNOMENU_MENU_BAR_BACKGROUND,
	GNOMENU_MENU_BAR_GRAVITY,
	GNOMENU_MENU_BAR_OVERFLOWN,
	GNOMENU_MENU_BAR_OWNER,
	GNOMENU_MENU_BAR_LENGTH
};
GnomenuMenuItem* gnomenu_menu_item_new (void);
GnomenuMenuItem* gnomenu_menu_item_construct (GType object_type);
#define GNOMENU_MENU_BAR_PROP_IMPORTANT (guint) 1
#define GNOMENU_MENU_BAR_OVERFLOWER_TEMPLATE "\n<menu>\n\t<item type=\"a\" id=\"_arrow_\">\n\t%s\n\t</item>\n</menu>\n"
GnomenuMenuBar* gnomenu_menu_bar_new (void);
GnomenuMenuBar* gnomenu_menu_bar_construct (GType object_type);
GnomenuMenuBar* gnomenu_menu_bar_new (void);
static void gnomenu_menu_bar_real_dispose (GObject* base);
gboolean gnomenu_item_is_child_of (GnomenuItem* self, GnomenuItem* possible_parent);
static char* gnomenu_menu_bar_overflown_path_to_path (GnomenuMenuBar* self, const char* path);
char* gnomenu_item_get_item_path (GnomenuItem* self);
GnomenuMenuItem* gnomenu_menu_bar_get (GnomenuMenuBar* self, const char* path);
static GnomenuMenuItem* gnomenu_menu_bar_resolve_item_maybe_from_overflown (GnomenuMenuBar* self, GnomenuMenuItem* item);
static void gnomenu_menu_bar_rebuild_overflown_menu (GnomenuMenuBar* self);
void gnomenu_menu_bar_emit_activate (GnomenuMenuBar* self, GnomenuMenuItem* item);
static void gnomenu_menu_bar_real_emit_activate (GnomenuMenuBar* self, GnomenuMenuItem* item);
void gnomenu_menu_bar_emit_select (GnomenuMenuBar* self, GnomenuMenuItem* item);
static void gnomenu_menu_bar_real_emit_select (GnomenuMenuBar* self, GnomenuMenuItem* item);
void gnomenu_menu_bar_emit_deselect (GnomenuMenuBar* self, GnomenuMenuItem* item);
static void gnomenu_menu_bar_real_emit_deselect (GnomenuMenuBar* self, GnomenuMenuItem* item);
const char* gnomenu_item_get_item_id (GnomenuItem* self);
gint gnomenu_item_get_item_position (GnomenuItem* self);
static void gnomenu_menu_bar_reset_bg_pixmap (GnomenuMenuBar* self);
static void gnomenu_menu_bar_real_style_set (GtkWidget* base, GtkStyle* old_style);
void gnomenu_item_set_has_sub_shell (GnomenuItem* self, gboolean value);
void gnomenu_item_set_item_id (GnomenuItem* self, const char* value);
void gnomenu_item_set_item_type (GnomenuItem* self, GnomenuItemType value);
GnomenuShell* gnomenu_item_get_sub_shell (GnomenuItem* self);
void gnomenu_parser_parse (GnomenuShell* shell, const char* description, GError** error);
static void gnomenu_menu_bar_setup_overflown_item (GnomenuMenuBar* self);
char* gnomenu_serializer_to_string (GObject* obj, gboolean pretty_print);
gint gnomenu_shell_get_length (GnomenuShell* self);
GnomenuItem* gnomenu_shell_get_item (GnomenuShell* self, gint position);
gboolean gnomenu_item_get_item_visible (GnomenuItem* self);
static gboolean gnomenu_menu_bar_child_need_overflown_item (GnomenuMenuBar* self, GtkWidget* child);
void gnomenu_item_set_item_visible (GnomenuItem* self, gboolean value);
GnomenuBackground* gnomenu_menu_bar_get_background (GnomenuMenuBar* self);
static gboolean gnomenu_menu_bar_real_move_selected (GtkMenuShell* base, gint distance);
static void gnomenu_menu_bar_real_forall (GtkContainer* base, gboolean include_internals, GtkCallback callback, void* callback_target);
static void gnomenu_menu_bar_real_realize (GtkWidget* base);
static void gnomenu_menu_bar_real_map (GtkWidget* base);
gboolean gnomenu_menu_bar_get_overflown (GnomenuMenuBar* self);
static void gnomenu_menu_bar_real_size_allocate (GtkWidget* base, const GdkRectangle* a);
static gboolean gnomenu_menu_bar_real_expose_event (GtkWidget* base, const GdkEventExpose* event);
static gboolean gnomenu_menu_bar_real_focus_out_event (GtkWidget* base, const GdkEventFocus* event);
static gboolean gnomenu_menu_bar_real_focus_in_event (GtkWidget* base, const GdkEventFocus* event);
static void gnomenu_menu_bar_real_size_request (GtkWidget* base, GtkRequisition* req);
GnomenuGravity gnomenu_menu_bar_get_gravity (GnomenuMenuBar* self);
void gnomenu_menu_item_set_gravity (GnomenuMenuItem* self, GnomenuGravity value);
static void gnomenu_menu_bar_real_insert (GtkMenuShell* base, GtkWidget* child, gint position);
GtkMenuItem* gtk_menu_shell_get_item (GtkMenuShell* menu_shell, gint position);
static GnomenuItem* gnomenu_menu_bar_real_get_item (GnomenuShell* base, gint position);
static GnomenuItem* gnomenu_menu_bar_real_get_item_by_id (GnomenuShell* base, const char* id);
gint gtk_menu_shell_get_item_position (GtkMenuShell* menu_shell, GtkMenuItem* item);
static gint gnomenu_menu_bar_real_get_item_position (GnomenuShell* base, GnomenuItem* item);
void gnomenu_menu_bar_set_background (GnomenuMenuBar* self, GnomenuBackground* value);
void gnomenu_menu_bar_set_gravity (GnomenuMenuBar* self, GnomenuGravity value);
gint gtk_menu_shell_length_without_truncated (GtkMenuShell* menu_shell);
void gtk_menu_shell_truncate (GtkMenuShell* menushell, gint length);
static GObject * gnomenu_menu_bar_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static gpointer gnomenu_menu_bar_parent_class = NULL;
static GnomenuShellIface* gnomenu_menu_bar_gnomenu_shell_parent_iface = NULL;
static void gnomenu_menu_bar_finalize (GObject* obj);
static void gnomenu_menu_bar_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void gnomenu_menu_bar_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);
static int _vala_strcmp0 (const char * str1, const char * str2);



/**
 * @return a new backround which is identical to this one.
 */
GnomenuBackground* gnomenu_background_clone (GnomenuBackground* self) {
	GnomenuBackground* rt;
	GdkPixmap* _tmp1_;
	GdkPixmap* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	rt = gnomenu_background_new ();
	rt->type = self->type;
	_tmp1_ = NULL;
	_tmp0_ = NULL;
	rt->pixmap = (_tmp1_ = (_tmp0_ = self->pixmap, (_tmp0_ == NULL) ? NULL : g_object_ref (_tmp0_)), (rt->pixmap == NULL) ? NULL : (rt->pixmap = (g_object_unref (rt->pixmap), NULL)), _tmp1_);
	rt->color = self->color;
	rt->offset_x = self->offset_x;
	rt->offset_y = self->offset_y;
	return rt;
}


/**
 *
 * This structure is used to represent a 'background' passed from
 * the panel library.
 * 
 */
GnomenuBackground* gnomenu_background_construct (GType object_type) {
	GnomenuBackground* self;
	self = (GnomenuBackground*) g_type_create_instance (object_type);
	return self;
}


GnomenuBackground* gnomenu_background_new (void) {
	return gnomenu_background_construct (GNOMENU_TYPE_BACKGROUND);
}


static void gnomenu_value_background_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void gnomenu_value_background_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		gnomenu_background_unref (value->data[0].v_pointer);
	}
}


static void gnomenu_value_background_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = gnomenu_background_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer gnomenu_value_background_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* gnomenu_value_background_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		GnomenuBackground* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = gnomenu_background_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* gnomenu_value_background_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	GnomenuBackground** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags && G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = gnomenu_background_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* gnomenu_param_spec_background (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	GnomenuParamSpecBackground* spec;
	g_return_val_if_fail (g_type_is_a (object_type, GNOMENU_TYPE_BACKGROUND), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer gnomenu_value_get_background (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GNOMENU_TYPE_BACKGROUND), NULL);
	return value->data[0].v_pointer;
}


void gnomenu_value_set_background (GValue* value, gpointer v_object) {
	GnomenuBackground* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GNOMENU_TYPE_BACKGROUND));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GNOMENU_TYPE_BACKGROUND));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		gnomenu_background_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		gnomenu_background_unref (old);
	}
}


static void gnomenu_background_class_init (GnomenuBackgroundClass * klass) {
	gnomenu_background_parent_class = g_type_class_peek_parent (klass);
	GNOMENU_BACKGROUND_CLASS (klass)->finalize = gnomenu_background_finalize;
}


static void gnomenu_background_instance_init (GnomenuBackground * self) {
	self->ref_count = 1;
}


static void gnomenu_background_finalize (GnomenuBackground* obj) {
	GnomenuBackground * self;
	self = GNOMENU_BACKGROUND (obj);
	(self->pixmap == NULL) ? NULL : (self->pixmap = (g_object_unref (self->pixmap), NULL));
}


GType gnomenu_background_get_type (void) {
	static GType gnomenu_background_type_id = 0;
	if (gnomenu_background_type_id == 0) {
		static const GTypeValueTable g_define_type_value_table = { gnomenu_value_background_init, gnomenu_value_background_free_value, gnomenu_value_background_copy_value, gnomenu_value_background_peek_pointer, "p", gnomenu_value_background_collect_value, "p", gnomenu_value_background_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (GnomenuBackgroundClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gnomenu_background_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GnomenuBackground), 0, (GInstanceInitFunc) gnomenu_background_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		gnomenu_background_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GnomenuBackground", &g_define_type_info, &g_define_type_fundamental_info, 0);
	}
	return gnomenu_background_type_id;
}


gpointer gnomenu_background_ref (gpointer instance) {
	GnomenuBackground* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void gnomenu_background_unref (gpointer instance) {
	GnomenuBackground* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		GNOMENU_BACKGROUND_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


GnomenuMenuBar* gnomenu_menu_bar_construct (GType object_type) {
	GnomenuMenuBar * self;
	self = g_object_newv (object_type, 0, NULL);
	return self;
}


GnomenuMenuBar* gnomenu_menu_bar_new (void) {
	return gnomenu_menu_bar_construct (GNOMENU_TYPE_MENU_BAR);
}


static void gnomenu_menu_bar_real_dispose (GObject* base) {
	GnomenuMenuBar * self;
	self = (GnomenuMenuBar*) base;
	if (!self->priv->disposed) {
		self->priv->disposed = TRUE;
	}
	G_OBJECT_CLASS (gnomenu_menu_bar_parent_class)->dispose ((GObject*) GTK_MENU_BAR (self));
}


static GnomenuMenuItem* gnomenu_menu_bar_resolve_item_maybe_from_overflown (GnomenuMenuBar* self, GnomenuMenuItem* item) {
	GnomenuMenuItem* _tmp3_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (item != NULL, NULL);
	if (gnomenu_item_is_child_of ((GnomenuItem*) item, (GnomenuItem*) self->priv->_overflown_item)) {
		char* _tmp0_;
		char* _tmp1_;
		char* path;
		GnomenuMenuItem* real_item;
		GnomenuMenuItem* _tmp2_;
		_tmp0_ = NULL;
		_tmp1_ = NULL;
		path = (_tmp1_ = gnomenu_menu_bar_overflown_path_to_path (self, _tmp0_ = gnomenu_item_get_item_path ((GnomenuItem*) item)), _tmp0_ = (g_free (_tmp0_), NULL), _tmp1_);
		g_debug ("menubar.vala:90: real_item is %s", path);
		real_item = gnomenu_menu_bar_get (self, path);
		_tmp2_ = NULL;
		return (_tmp2_ = real_item, path = (g_free (path), NULL), _tmp2_);
	}
	_tmp3_ = NULL;
	return (_tmp3_ = item, (_tmp3_ == NULL) ? NULL : g_object_ref (_tmp3_));
}


static void gnomenu_menu_bar_real_emit_activate (GnomenuMenuBar* self, GnomenuMenuItem* item) {
	char* _tmp0_;
	GnomenuMenuItem* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (item != NULL);
	if (item == self->priv->_overflown_item) {
		gnomenu_menu_bar_rebuild_overflown_menu (self);
		return;
	}
	_tmp0_ = NULL;
	g_debug ("menubar.vala:105: item %s activated", _tmp0_ = gnomenu_item_get_item_path ((GnomenuItem*) item));
	_tmp0_ = (g_free (_tmp0_), NULL);
	_tmp1_ = NULL;
	g_signal_emit_by_name (self, "activate", _tmp1_ = gnomenu_menu_bar_resolve_item_maybe_from_overflown (self, item));
	(_tmp1_ == NULL) ? NULL : (_tmp1_ = (g_object_unref (_tmp1_), NULL));
}


void gnomenu_menu_bar_emit_activate (GnomenuMenuBar* self, GnomenuMenuItem* item) {
	GNOMENU_MENU_BAR_GET_CLASS (self)->emit_activate (self, item);
}


static void gnomenu_menu_bar_real_emit_select (GnomenuMenuBar* self, GnomenuMenuItem* item) {
	char* _tmp0_;
	GnomenuMenuItem* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (item != NULL);
	if (item == self->priv->_overflown_item) {
		return;
	}
	_tmp0_ = NULL;
	g_debug ("menubar.vala:115: item %s selected", _tmp0_ = gnomenu_item_get_item_path ((GnomenuItem*) item));
	_tmp0_ = (g_free (_tmp0_), NULL);
	_tmp1_ = NULL;
	g_signal_emit_by_name (self, "select", _tmp1_ = gnomenu_menu_bar_resolve_item_maybe_from_overflown (self, item));
	(_tmp1_ == NULL) ? NULL : (_tmp1_ = (g_object_unref (_tmp1_), NULL));
}


void gnomenu_menu_bar_emit_select (GnomenuMenuBar* self, GnomenuMenuItem* item) {
	GNOMENU_MENU_BAR_GET_CLASS (self)->emit_select (self, item);
}


static void gnomenu_menu_bar_real_emit_deselect (GnomenuMenuBar* self, GnomenuMenuItem* item) {
	GnomenuMenuItem* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (item != NULL);
	if (item == self->priv->_overflown_item) {
		return;
	}
	_tmp0_ = NULL;
	g_signal_emit_by_name (self, "deselect", _tmp0_ = gnomenu_menu_bar_resolve_item_maybe_from_overflown (self, item));
	(_tmp0_ == NULL) ? NULL : (_tmp0_ = (g_object_unref (_tmp0_), NULL));
}


void gnomenu_menu_bar_emit_deselect (GnomenuMenuBar* self, GnomenuMenuItem* item) {
	GNOMENU_MENU_BAR_GET_CLASS (self)->emit_deselect (self, item);
}


static glong string_get_length (const char* self) {
	g_return_val_if_fail (self != NULL, 0L);
	return g_utf8_strlen (self, -1);
}


static char* gnomenu_menu_bar_overflown_path_to_path (GnomenuMenuBar* self, const char* path) {
	gint slashes;
	GString* sb;
	char* _tmp2_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (path != NULL, NULL);
	slashes = 0;
	sb = g_string_new ("");
	{
		gint i;
		/***
		 * path = "00001234:/0/1/234/512";
		 * sb =   "00001234:  /1/234/512";
		 */
		i = 0;
		for (; i < string_get_length (path); i++) {
			if (g_utf8_get_char (g_utf8_offset_to_pointer (path, i)) == '/') {
				slashes++;
			}
			if (slashes != 1) {
				g_string_append_unichar (sb, g_utf8_get_char (g_utf8_offset_to_pointer (path, i)));
			}
		}
	}
	if (slashes > 1) {
		const char* _tmp0_;
		char* _tmp1_;
		_tmp0_ = NULL;
		_tmp1_ = NULL;
		return (_tmp1_ = (_tmp0_ = sb->str, (_tmp0_ == NULL) ? NULL : g_strdup (_tmp0_)), (sb == NULL) ? NULL : (sb = (g_string_free (sb, TRUE), NULL)), _tmp1_);
	}
	_tmp2_ = NULL;
	return (_tmp2_ = NULL, (sb == NULL) ? NULL : (sb = (g_string_free (sb, TRUE), NULL)), _tmp2_);
}


/**
 * Look up a child item from a path.
 * The path is a string constructed by two parts:
 *
 * [rev:]/id/id/id
 *
 * where rev: is an integer stamp, and id can be either
 * the id property or the position of the menu item.
 *
 * return a strong reference of the menu item if found;
 * null if not.
 */
GnomenuMenuItem* gnomenu_menu_bar_get (GnomenuMenuBar* self, const char* path) {
	char** _tmp1_;
	gint tokens_size;
	gint tokens_length1;
	char** _tmp0_;
	char** tokens;
	GnomenuShell* _tmp2_;
	GnomenuShell* shell;
	GnomenuMenuItem* _tmp17_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (path != NULL, NULL);
	_tmp1_ = NULL;
	_tmp0_ = NULL;
	tokens = (_tmp1_ = _tmp0_ = g_strsplit_set (path, "/", -1), tokens_length1 = _vala_array_length (_tmp0_), tokens_size = tokens_length1, _tmp1_);
	tokens_length1 = (gint) g_strv_length (tokens);
	_tmp2_ = NULL;
	shell = (_tmp2_ = (GnomenuShell*) self, (_tmp2_ == NULL) ? NULL : g_object_ref (_tmp2_));
	{
		gint i;
		/*
		weak string rev = tokens[0];
		FIXME: check rev */
		i = 1;
		for (; i < tokens_length1; i++) {
			const char* token;
			GnomenuShell* _tmp3_;
			GList* children;
			GnomenuMenuItem* item;
			GnomenuShell* _tmp15_;
			GnomenuShell* _tmp14_;
			GtkMenu* _tmp13_;
			token = tokens[i];
			_tmp3_ = NULL;
			children = gtk_container_get_children ((GtkContainer*) (_tmp3_ = shell, GTK_IS_MENU_SHELL (_tmp3_) ? ((GtkMenuShell*) _tmp3_) : NULL));
			item = NULL;
			{
				GList* child_collection;
				GList* child_it;
				child_collection = children;
				for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
					GtkWidget* child;
					child = (GtkWidget*) child_it->data;
					{
						GnomenuMenuItem* _tmp5_;
						GtkWidget* _tmp4_;
						GnomenuMenuItem* child_item;
						_tmp5_ = NULL;
						_tmp4_ = NULL;
						child_item = (_tmp5_ = (_tmp4_ = child, GNOMENU_IS_MENU_ITEM (_tmp4_) ? ((GnomenuMenuItem*) _tmp4_) : NULL), (_tmp5_ == NULL) ? NULL : g_object_ref (_tmp5_));
						if (child_item != NULL) {
							gboolean _tmp6_;
							_tmp6_ = FALSE;
							if (_vala_strcmp0 (gnomenu_item_get_item_id ((GnomenuItem*) child_item), token) == 0) {
								_tmp6_ = TRUE;
							} else {
								gboolean _tmp7_;
								_tmp7_ = FALSE;
								if (gnomenu_item_get_item_id ((GnomenuItem*) child_item) == NULL) {
									char* _tmp8_;
									_tmp8_ = NULL;
									_tmp7_ = _vala_strcmp0 (_tmp8_ = g_strdup_printf ("%i", gnomenu_item_get_item_position ((GnomenuItem*) child_item)), token) == 0;
									_tmp8_ = (g_free (_tmp8_), NULL);
								} else {
									_tmp7_ = FALSE;
								}
								_tmp6_ = _tmp7_;
							}
							if (_tmp6_) {
								GnomenuMenuItem* _tmp10_;
								GnomenuMenuItem* _tmp9_;
								_tmp10_ = NULL;
								_tmp9_ = NULL;
								item = (_tmp10_ = (_tmp9_ = child_item, (_tmp9_ == NULL) ? NULL : g_object_ref (_tmp9_)), (item == NULL) ? NULL : (item = (g_object_unref (item), NULL)), _tmp10_);
								(child_item == NULL) ? NULL : (child_item = (g_object_unref (child_item), NULL));
								break;
							}
						}
						(child_item == NULL) ? NULL : (child_item = (g_object_unref (child_item), NULL));
					}
				}
			}
			if (i == (tokens_length1 - 1)) {
				GnomenuMenuItem* _tmp11_;
				_tmp11_ = NULL;
				return (_tmp11_ = item, (children == NULL) ? NULL : (children = (g_list_free (children), NULL)), tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL), (shell == NULL) ? NULL : (shell = (g_object_unref (shell), NULL)), _tmp11_);
			}
			if (item == NULL) {
				GnomenuMenuItem* _tmp12_;
				_tmp12_ = NULL;
				return (_tmp12_ = NULL, (children == NULL) ? NULL : (children = (g_list_free (children), NULL)), (item == NULL) ? NULL : (item = (g_object_unref (item), NULL)), tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL), (shell == NULL) ? NULL : (shell = (g_object_unref (shell), NULL)), _tmp12_);
			}
			_tmp15_ = NULL;
			_tmp14_ = NULL;
			_tmp13_ = NULL;
			shell = (_tmp15_ = (_tmp14_ = (_tmp13_ = gtk_menu_item_get_submenu ((GtkMenuItem*) item), GNOMENU_IS_SHELL (_tmp13_) ? ((GnomenuShell*) _tmp13_) : NULL), (_tmp14_ == NULL) ? NULL : g_object_ref (_tmp14_)), (shell == NULL) ? NULL : (shell = (g_object_unref (shell), NULL)), _tmp15_);
			if (shell == NULL) {
				GnomenuMenuItem* _tmp16_;
				_tmp16_ = NULL;
				return (_tmp16_ = NULL, (children == NULL) ? NULL : (children = (g_list_free (children), NULL)), (item == NULL) ? NULL : (item = (g_object_unref (item), NULL)), tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL), (shell == NULL) ? NULL : (shell = (g_object_unref (shell), NULL)), _tmp16_);
			}
			(children == NULL) ? NULL : (children = (g_list_free (children), NULL));
			(item == NULL) ? NULL : (item = (g_object_unref (item), NULL));
		}
	}
	_tmp17_ = NULL;
	return (_tmp17_ = NULL, tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL), (shell == NULL) ? NULL : (shell = (g_object_unref (shell), NULL)), _tmp17_);
}


static void gnomenu_menu_bar_real_style_set (GtkWidget* base, GtkStyle* old_style) {
	GnomenuMenuBar * self;
	self = (GnomenuMenuBar*) base;
	GTK_WIDGET_CLASS (gnomenu_menu_bar_parent_class)->style_set ((GtkWidget*) GTK_MENU_BAR (self), old_style);
	gtk_widget_set_style ((GtkWidget*) self->priv->_overflown_item, gtk_widget_get_style ((GtkWidget*) self));
	gnomenu_menu_bar_reset_bg_pixmap (self);
}


static void gnomenu_menu_bar_setup_overflown_item (GnomenuMenuBar* self) {
	GError * _inner_error_;
	GnomenuShell* _tmp0_;
	GnomenuShell* shell;
	g_return_if_fail (self != NULL);
	_inner_error_ = NULL;
	gtk_widget_set_parent ((GtkWidget*) self->priv->_overflown_item, (GtkWidget*) self);
	gtk_widget_set_style ((GtkWidget*) self->priv->_overflown_item, gtk_widget_get_style ((GtkWidget*) self));
	gnomenu_item_set_has_sub_shell ((GnomenuItem*) self->priv->_overflown_item, TRUE);
	g_object_set ((GtkWidget*) self->priv->_overflown_item, "visible", TRUE, NULL);
	gnomenu_item_set_item_id ((GnomenuItem*) self->priv->_overflown_item, "_arrow_");
	gnomenu_item_set_item_type ((GnomenuItem*) self->priv->_overflown_item, GNOMENU_ITEM_TYPE_ARROW);
	_tmp0_ = NULL;
	shell = (_tmp0_ = gnomenu_item_get_sub_shell ((GnomenuItem*) self->priv->_overflown_item), (_tmp0_ == NULL) ? NULL : g_object_ref (_tmp0_));
	{
		char* _tmp1_;
		_tmp1_ = NULL;
		gnomenu_parser_parse (shell, _tmp1_ = g_strdup_printf (GNOMENU_MENU_BAR_OVERFLOWER_TEMPLATE, "<menu/>"), &_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch0_g_error;
			goto __finally0;
		}
		_tmp1_ = (g_free (_tmp1_), NULL);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			g_warning ("menubar.vala:296: %s", e->message);
			(e == NULL) ? NULL : (e = (g_error_free (e), NULL));
		}
	}
	__finally0:
	if (_inner_error_ != NULL) {
		(shell == NULL) ? NULL : (shell = (g_object_unref (shell), NULL));
		g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
		g_clear_error (&_inner_error_);
		return;
	}
	(shell == NULL) ? NULL : (shell = (g_object_unref (shell), NULL));
}


static void gnomenu_menu_bar_rebuild_overflown_menu (GnomenuMenuBar* self) {
	GError * _inner_error_;
	GnomenuShell* _tmp0_;
	GnomenuShell* shell;
	GString* sb;
	char* _tmp1_;
	g_return_if_fail (self != NULL);
	_inner_error_ = NULL;
	g_debug ("menubar.vala:300: rebuild_overflown_menu");
	_tmp0_ = NULL;
	shell = (_tmp0_ = gnomenu_item_get_sub_shell ((GnomenuItem*) self->priv->_overflown_item), (_tmp0_ == NULL) ? NULL : g_object_ref (_tmp0_));
	sb = g_string_new ("");
	_tmp1_ = NULL;
	g_string_append (sb, _tmp1_ = gnomenu_serializer_to_string ((GObject*) self, FALSE));
	_tmp1_ = (g_free (_tmp1_), NULL);
	{
		gnomenu_parser_parse (shell, sb->str, &_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch1_g_error;
			goto __finally1;
		}
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			g_warning ("menubar.vala:307: %s", e->message);
			(e == NULL) ? NULL : (e = (g_error_free (e), NULL));
		}
	}
	__finally1:
	if (_inner_error_ != NULL) {
		(shell == NULL) ? NULL : (shell = (g_object_unref (shell), NULL));
		(sb == NULL) ? NULL : (sb = (g_string_free (sb, TRUE), NULL));
		g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
		g_clear_error (&_inner_error_);
		return;
	}
	{
		gint i;
		i = 0;
		for (; i < gnomenu_shell_get_length ((GnomenuShell*) self); i++) {
			GnomenuItem* item;
			GnomenuItem* proxy_item;
			GtkWidget* _tmp3_;
			GnomenuItem* _tmp2_;
			GtkWidget* child;
			gboolean _tmp4_;
			item = gnomenu_shell_get_item ((GnomenuShell*) self, i);
			proxy_item = gnomenu_shell_get_item (shell, i);
			_tmp3_ = NULL;
			_tmp2_ = NULL;
			child = (_tmp3_ = (_tmp2_ = item, GTK_IS_WIDGET (_tmp2_) ? ((GtkWidget*) _tmp2_) : NULL), (_tmp3_ == NULL) ? NULL : g_object_ref (_tmp3_));
			_tmp4_ = FALSE;
			if (gnomenu_item_get_item_visible (item)) {
				_tmp4_ = gnomenu_menu_bar_child_need_overflown_item (self, child);
			} else {
				_tmp4_ = FALSE;
			}
			gnomenu_item_set_item_visible (proxy_item, _tmp4_);
			(item == NULL) ? NULL : (item = (g_object_unref (item), NULL));
			(proxy_item == NULL) ? NULL : (proxy_item = (g_object_unref (proxy_item), NULL));
			(child == NULL) ? NULL : (child = (g_object_unref (child), NULL));
		}
	}
	(shell == NULL) ? NULL : (shell = (g_object_unref (shell), NULL));
	(sb == NULL) ? NULL : (sb = (g_string_free (sb, TRUE), NULL));
}


static gboolean gnomenu_menu_bar_child_need_overflown_item (GnomenuMenuBar* self, GtkWidget* child) {
	gint lhs;
	gint rhs;
	GtkAllocation a;
	GtkAllocation oa;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (child != NULL, FALSE);
	lhs = 0;
	rhs = 0;
	a = child->allocation;
	oa = ((GtkWidget*) self->priv->_overflown_item)->allocation;
	switch (gtk_menu_bar_get_pack_direction ((GtkMenuBar*) self)) {
		case GTK_PACK_DIRECTION_LTR:
		{
			lhs = a.x + a.width;
			rhs = ((GtkWidget*) self)->allocation.width - oa.width;
			break;
		}
		case GTK_PACK_DIRECTION_RTL:
		{
			lhs = 0 + oa.width;
			rhs = a.x;
			break;
		}
		case GTK_PACK_DIRECTION_BTT:
		{
			lhs = 0 + oa.height;
			rhs = a.y;
			break;
		}
		case GTK_PACK_DIRECTION_TTB:
		{
			lhs = a.y + a.height;
			rhs = ((GtkWidget*) self)->allocation.height - oa.height;
			break;
		}
	}
	return lhs > rhs;
}


static void gnomenu_menu_bar_reset_bg_pixmap (GnomenuMenuBar* self) {
	g_return_if_fail (self != NULL);
	if (gnomenu_menu_bar_get_background (self)->type != GNOMENU_BACKGROUND_TYPE_PIXMAP) {
		return;
	}
	if (0 != (GTK_WIDGET_FLAGS ((GtkWidget*) self) & GTK_REALIZED)) {
		GdkPixmap* pixmap;
		cairo_t* cairo;
		cairo_pattern_t* pattern;
		GdkPixmap* _tmp2_;
		GdkPixmap* *_tmp1_;
		GdkPixmap* _tmp0_;
		pixmap = gdk_pixmap_new ((GdkDrawable*) ((GtkWidget*) self)->window, ((GtkWidget*) self)->allocation.width, ((GtkWidget*) self)->allocation.height, -1);
		g_assert (GDK_IS_DRAWABLE (((GtkWidget*) self)->window));
		g_assert (GDK_IS_DRAWABLE (pixmap));
		cairo = gdk_cairo_create ((GdkDrawable*) pixmap);
		g_assert (cairo != NULL);
		g_assert (GDK_IS_DRAWABLE (self->priv->_background->pixmap));
		gdk_cairo_set_source_pixmap (cairo, self->priv->_background->pixmap, (double) (-self->priv->_background->offset_x), (double) (-self->priv->_background->offset_y));
		pattern = cairo_get_source (cairo);
		cairo_pattern_set_extend (pattern, CAIRO_EXTEND_REPEAT);
		cairo_rectangle (cairo, (double) 0, (double) 0, (double) ((GtkWidget*) self)->allocation.width, (double) ((GtkWidget*) self)->allocation.height);
		cairo_fill (cairo);
		_tmp2_ = NULL;
		_tmp0_ = NULL;
		_tmp1_ = &gtk_widget_get_style ((GtkWidget*) self)->bg_pixmap[(gint) GTK_STATE_NORMAL];
		(*_tmp1_) = (_tmp2_ = (_tmp0_ = pixmap, (_tmp0_ == NULL) ? NULL : g_object_ref (_tmp0_)), ((*_tmp1_) == NULL) ? NULL : ((*_tmp1_) = (g_object_unref ((*_tmp1_)), NULL)), _tmp2_);
		gtk_style_attach (gtk_widget_get_style ((GtkWidget*) self), ((GtkWidget*) self)->window);
		gtk_style_set_background (gtk_widget_get_style ((GtkWidget*) self), ((GtkWidget*) self)->window, GTK_STATE_NORMAL);
		gtk_widget_queue_draw ((GtkWidget*) self);
		(pixmap == NULL) ? NULL : (pixmap = (g_object_unref (pixmap), NULL));
		(cairo == NULL) ? NULL : (cairo = (cairo_destroy (cairo), NULL));
	}
}


static gboolean gnomenu_menu_bar_real_move_selected (GtkMenuShell* base, gint distance) {
	GnomenuMenuBar * self;
	self = (GnomenuMenuBar*) base;
	if (((GtkMenuShell*) self)->active_menu_item == GTK_WIDGET (self->priv->_overflown_item)) {
		if (distance == 1) {
			gtk_menu_shell_select_first ((GtkMenuShell*) self, TRUE);
		} else {
			{
				gint i;
				i = gnomenu_shell_get_length ((GnomenuShell*) self) - 1;
				for (; i >= 0; i--) {
					GnomenuItem* item;
					GtkWidget* _tmp1_;
					GnomenuItem* _tmp0_;
					GtkWidget* child;
					item = gnomenu_shell_get_item ((GnomenuShell*) self, i);
					_tmp1_ = NULL;
					_tmp0_ = NULL;
					child = (_tmp1_ = (_tmp0_ = item, GTK_IS_WIDGET (_tmp0_) ? ((GtkWidget*) _tmp0_) : NULL), (_tmp1_ == NULL) ? NULL : g_object_ref (_tmp1_));
					if (!gnomenu_menu_bar_child_need_overflown_item (self, child)) {
						gtk_menu_shell_select_item ((GtkMenuShell*) self, child);
					}
					(item == NULL) ? NULL : (item = (g_object_unref (item), NULL));
					(child == NULL) ? NULL : (child = (g_object_unref (child), NULL));
				}
			}
		}
		return TRUE;
	} else {
		/*FIXME:
		 * Move from the last visible item to _overflown_item
		 * or from the first visible item to _overflown_item
		 */
		return GTK_MENU_SHELL_CLASS (gnomenu_menu_bar_parent_class)->move_selected ((GtkMenuShell*) GTK_MENU_BAR (self), distance);
	}
}


static void gnomenu_menu_bar_real_forall (GtkContainer* base, gboolean include_internals, GtkCallback callback, void* callback_target) {
	GnomenuMenuBar * self;
	self = (GnomenuMenuBar*) base;
	if (include_internals) {
		callback ((GtkWidget*) self->priv->_overflown_item, callback_target);
	}
	GTK_CONTAINER_CLASS (gnomenu_menu_bar_parent_class)->forall ((GtkContainer*) GTK_MENU_BAR (self), include_internals, callback, callback_target);
}


static void gnomenu_menu_bar_real_realize (GtkWidget* base) {
	GnomenuMenuBar * self;
	self = (GnomenuMenuBar*) base;
	GTK_WIDGET_CLASS (gnomenu_menu_bar_parent_class)->realize ((GtkWidget*) GTK_MENU_BAR (self));
	gnomenu_menu_bar_reset_bg_pixmap (self);
}


static void gnomenu_menu_bar_real_map (GtkWidget* base) {
	GnomenuMenuBar * self;
	self = (GnomenuMenuBar*) base;
	GTK_WIDGET_CLASS (gnomenu_menu_bar_parent_class)->map ((GtkWidget*) GTK_MENU_BAR (self));
}


static void gnomenu_menu_bar_real_size_allocate (GtkWidget* base, const GdkRectangle* a) {
	GnomenuMenuBar * self;
	gboolean need_reset_bg_pixmap;
	gint delta_x;
	gint delta_y;
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GdkRectangle oa = {0, 0, 0, 0};
	GtkRequisition or = {0};
	self = (GnomenuMenuBar*) base;
	need_reset_bg_pixmap = FALSE;
	delta_x = (*a).x - ((GtkWidget*) self)->allocation.x;
	delta_y = (*a).y - ((GtkWidget*) self)->allocation.y;
	_tmp0_ = FALSE;
	_tmp1_ = FALSE;
	_tmp2_ = FALSE;
	if (delta_x != 0) {
		_tmp2_ = TRUE;
	} else {
		_tmp2_ = delta_y != 0;
	}
	if (_tmp2_) {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = (*a).width != ((GtkWidget*) self)->allocation.width;
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = (*a).height != ((GtkWidget*) self)->allocation.height;
	}
	if (_tmp0_) {
		need_reset_bg_pixmap = TRUE;
	}
	gnomenu_menu_bar_get_background (self)->offset_x = gnomenu_menu_bar_get_background (self)->offset_x + delta_x;
	gnomenu_menu_bar_get_background (self)->offset_y = gnomenu_menu_bar_get_background (self)->offset_y + delta_y;
	((GtkWidget*) self)->allocation = (GtkAllocation) (*a);
	/*To make 'overflown' happy*/
	GTK_WIDGET_CLASS (gnomenu_menu_bar_parent_class)->size_allocate ((GtkWidget*) GTK_MENU_BAR (self), &(*a));
	gtk_widget_get_child_requisition ((GtkWidget*) self->priv->_overflown_item, &or);
	switch (gtk_menu_bar_get_pack_direction ((GtkMenuBar*) self)) {
		case GTK_PACK_DIRECTION_TTB:
		{
			oa.height = or.height;
			oa.width = (*a).width;
			oa.x = 0;
			oa.y = (*a).height - oa.height;
			break;
		}
		case GTK_PACK_DIRECTION_BTT:
		{
			oa.height = or.height;
			oa.width = (*a).width;
			oa.x = 0;
			oa.y = 0;
			break;
		}
		case GTK_PACK_DIRECTION_RTL:
		{
			oa.height = (*a).height;
			oa.width = or.width;
			oa.x = 0;
			oa.y = 0;
			break;
		}
		default:
		{
			oa.width = or.width;
			oa.height = (*a).height;
			oa.x = (*a).width - oa.width;
			oa.y = 0;
			break;
		}
	}
	gtk_widget_size_allocate ((GtkWidget*) self->priv->_overflown_item, &oa);
	if (gnomenu_menu_bar_get_overflown (self)) {
		gtk_widget_set_child_visible ((GtkWidget*) self->priv->_overflown_item, TRUE);
		{
			gint i;
			i = 0;
			for (; i < gnomenu_shell_get_length ((GnomenuShell*) self); i++) {
				GnomenuItem* item;
				GtkWidget* _tmp4_;
				GnomenuItem* _tmp3_;
				GtkWidget* child;
				item = gnomenu_shell_get_item ((GnomenuShell*) self, i);
				_tmp4_ = NULL;
				_tmp3_ = NULL;
				child = (_tmp4_ = (_tmp3_ = item, GTK_IS_WIDGET (_tmp3_) ? ((GtkWidget*) _tmp3_) : NULL), (_tmp4_ == NULL) ? NULL : g_object_ref (_tmp4_));
				gtk_widget_set_child_visible (child, !gnomenu_menu_bar_child_need_overflown_item (self, child));
				(item == NULL) ? NULL : (item = (g_object_unref (item), NULL));
				(child == NULL) ? NULL : (child = (g_object_unref (child), NULL));
			}
		}
	} else {
		gtk_widget_set_child_visible ((GtkWidget*) self->priv->_overflown_item, FALSE);
		{
			gint i;
			i = 0;
			for (; i < gnomenu_shell_get_length ((GnomenuShell*) self); i++) {
				GnomenuItem* item;
				GtkWidget* _tmp6_;
				GnomenuItem* _tmp5_;
				GtkWidget* child;
				item = gnomenu_shell_get_item ((GnomenuShell*) self, i);
				_tmp6_ = NULL;
				_tmp5_ = NULL;
				child = (_tmp6_ = (_tmp5_ = item, GTK_IS_WIDGET (_tmp5_) ? ((GtkWidget*) _tmp5_) : NULL), (_tmp6_ == NULL) ? NULL : g_object_ref (_tmp6_));
				gtk_widget_set_child_visible (child, TRUE);
				(item == NULL) ? NULL : (item = (g_object_unref (item), NULL));
				(child == NULL) ? NULL : (child = (g_object_unref (child), NULL));
			}
		}
	}
	if (need_reset_bg_pixmap) {
		gnomenu_menu_bar_reset_bg_pixmap (self);
	}
}


static gboolean gnomenu_menu_bar_real_expose_event (GtkWidget* base, const GdkEventExpose* event) {
	GnomenuMenuBar * self;
	self = (GnomenuMenuBar*) base;
	if ((GTK_WIDGET_FLAGS ((GtkWidget*) self) & GTK_HAS_FOCUS) != 0) {
		gtk_paint_focus (gtk_widget_get_style ((GtkWidget*) self), ((GtkWidget*) self)->window, (GtkStateType) ((GtkWidget*) self)->state, NULL, (GtkWidget*) self, "menubar-applet", 0, 0, -1, -1);
	}
	{
		GList* child_collection;
		GList* child_it;
		child_collection = gtk_container_get_children ((GtkContainer*) self);
		for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
			GtkWidget* child;
			child = (GtkWidget*) child_it->data;
			{
				gtk_container_propagate_expose ((GtkContainer*) self, child, &(*event));
			}
		}
		(child_collection == NULL) ? NULL : (child_collection = (g_list_free (child_collection), NULL));
	}
	gtk_container_propagate_expose ((GtkContainer*) self, (GtkWidget*) self->priv->_overflown_item, &(*event));
	return FALSE;
}


static gboolean gnomenu_menu_bar_real_focus_out_event (GtkWidget* base, const GdkEventFocus* event) {
	GnomenuMenuBar * self;
	self = (GnomenuMenuBar*) base;
	gtk_widget_queue_draw ((GtkWidget*) self);
	return FALSE;
}


static gboolean gnomenu_menu_bar_real_focus_in_event (GtkWidget* base, const GdkEventFocus* event) {
	GnomenuMenuBar * self;
	self = (GnomenuMenuBar*) base;
	gtk_widget_queue_draw ((GtkWidget*) self);
	return FALSE;
}


static void gnomenu_menu_bar_real_size_request (GtkWidget* base, GtkRequisition* req) {
	GnomenuMenuBar * self;
	GtkRequisition r = {0, 0};
	self = (GnomenuMenuBar*) base;
	GTK_WIDGET_CLASS (gnomenu_menu_bar_parent_class)->size_request ((GtkWidget*) GTK_MENU_BAR (self), &(*req));
	gtk_widget_size_request ((GtkWidget*) self->priv->_overflown_item, &r);
	if (r.width > (*req).width) {
		(*req).width = r.width;
	}
	if (r.height > (*req).height) {
		(*req).height = r.height;
	}
}


static void gnomenu_menu_bar_real_insert (GtkMenuShell* base, GtkWidget* child, gint position) {
	GnomenuMenuBar * self;
	GtkWidget* _tmp0_;
	self = (GnomenuMenuBar*) base;
	g_return_if_fail (child != NULL);
	GTK_MENU_SHELL_CLASS (gnomenu_menu_bar_parent_class)->insert ((GtkMenuShell*) GTK_MENU_BAR (self), child, position);
	_tmp0_ = NULL;
	gnomenu_menu_item_set_gravity ((_tmp0_ = child, GNOMENU_IS_MENU_ITEM (_tmp0_) ? ((GnomenuMenuItem*) _tmp0_) : NULL), gnomenu_menu_bar_get_gravity (self));
}


static GnomenuItem* gnomenu_menu_bar_real_get_item (GnomenuShell* base, gint position) {
	GnomenuMenuBar * self;
	GnomenuItem* _tmp1_;
	GtkMenuItem* _tmp0_;
	self = (GnomenuMenuBar*) base;
	_tmp1_ = NULL;
	_tmp0_ = NULL;
	return (_tmp1_ = (_tmp0_ = gtk_menu_shell_get_item (self, position), GNOMENU_IS_ITEM (_tmp0_) ? ((GnomenuItem*) _tmp0_) : NULL), (_tmp1_ == NULL) ? NULL : g_object_ref (_tmp1_));
}


static GnomenuItem* gnomenu_menu_bar_real_get_item_by_id (GnomenuShell* base, const char* id) {
	GnomenuMenuBar * self;
	self = (GnomenuMenuBar*) base;
	g_return_val_if_fail (id != NULL, NULL);
	{
		GList* child_collection;
		GList* child_it;
		child_collection = gtk_container_get_children ((GtkContainer*) self);
		for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
			GtkWidget* child;
			child = (GtkWidget*) child_it->data;
			{
				GnomenuItem* _tmp1_;
				GtkWidget* _tmp0_;
				GnomenuItem* item;
				_tmp1_ = NULL;
				_tmp0_ = NULL;
				item = (_tmp1_ = (_tmp0_ = child, GNOMENU_IS_ITEM (_tmp0_) ? ((GnomenuItem*) _tmp0_) : NULL), (_tmp1_ == NULL) ? NULL : g_object_ref (_tmp1_));
				if (item == NULL) {
					(item == NULL) ? NULL : (item = (g_object_unref (item), NULL));
					continue;
				}
				if (_vala_strcmp0 (gnomenu_item_get_item_id (item), id) == 0) {
					GnomenuItem* _tmp2_;
					_tmp2_ = NULL;
					return (_tmp2_ = item, (child_collection == NULL) ? NULL : (child_collection = (g_list_free (child_collection), NULL)), _tmp2_);
				}
				(item == NULL) ? NULL : (item = (g_object_unref (item), NULL));
			}
		}
		(child_collection == NULL) ? NULL : (child_collection = (g_list_free (child_collection), NULL));
	}
	return NULL;
}


static gint gnomenu_menu_bar_real_get_item_position (GnomenuShell* base, GnomenuItem* item) {
	GnomenuMenuBar * self;
	GnomenuItem* _tmp0_;
	self = (GnomenuMenuBar*) base;
	g_return_val_if_fail (item != NULL, 0);
	_tmp0_ = NULL;
	return gtk_menu_shell_get_item_position (self, (_tmp0_ = item, GNOMENU_IS_MENU_ITEM (_tmp0_) ? ((GnomenuMenuItem*) _tmp0_) : NULL));
}


GnomenuBackground* gnomenu_menu_bar_get_background (GnomenuMenuBar* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return self->priv->_background;
}


void gnomenu_menu_bar_set_background (GnomenuMenuBar* self, GnomenuBackground* value) {
	GnomenuBackgroundType old_type;
	GdkColor old_color;
	GdkPixmap* _tmp2_;
	GdkPixmap* _tmp1_;
	g_return_if_fail (self != NULL);
	old_type = self->priv->_background->type;
	old_color = self->priv->_background->color;
	self->priv->_background->type = value->type;
	_tmp2_ = NULL;
	_tmp1_ = NULL;
	self->priv->_background->pixmap = (_tmp2_ = (_tmp1_ = value->pixmap, (_tmp1_ == NULL) ? NULL : g_object_ref (_tmp1_)), (self->priv->_background->pixmap == NULL) ? NULL : (self->priv->_background->pixmap = (g_object_unref (self->priv->_background->pixmap), NULL)), _tmp2_);
	self->priv->_background->color = value->color;
	self->priv->_background->offset_x = value->offset_x;
	self->priv->_background->offset_y = value->offset_y;
	switch (self->priv->_background->type) {
		case GNOMENU_BACKGROUND_TYPE_NONE:
		{
			if (old_type != self->priv->_background->type) {
				GtkRcStyle* rc_style;
				gtk_widget_set_style ((GtkWidget*) self, NULL);
				rc_style = gtk_rc_style_new ();
				gtk_widget_modify_style ((GtkWidget*) self, rc_style);
				(rc_style == NULL) ? NULL : (rc_style = (g_object_unref (rc_style), NULL));
			}
			break;
		}
		case GNOMENU_BACKGROUND_TYPE_COLOR:
		{
			gboolean _tmp3_;
			_tmp3_ = FALSE;
			if (old_type != self->priv->_background->type) {
				_tmp3_ = TRUE;
			} else {
				gboolean _tmp4_;
				_tmp4_ = FALSE;
				if (old_type == self->priv->_background->type) {
					_tmp4_ = !gdk_color_equal (&old_color, &self->priv->_background->color);
				} else {
					_tmp4_ = FALSE;
				}
				_tmp3_ = _tmp4_;
			}
			if (_tmp3_) {
				gtk_widget_modify_bg ((GtkWidget*) self, GTK_STATE_NORMAL, &self->priv->_background->color);
			}
			break;
		}
		case GNOMENU_BACKGROUND_TYPE_PIXMAP:
		{
			gnomenu_menu_bar_reset_bg_pixmap (self);
			break;
		}
	}
	g_object_notify ((GObject *) self, "background");
}


GnomenuGravity gnomenu_menu_bar_get_gravity (GnomenuMenuBar* self) {
	g_return_val_if_fail (self != NULL, 0);
	return self->priv->_gravity;
}


void gnomenu_menu_bar_set_gravity (GnomenuMenuBar* self, GnomenuGravity value) {
	g_return_if_fail (self != NULL);
	if (self->priv->_gravity == value) {
		return;
	}
	self->priv->_gravity = value;
	{
		GList* child_collection;
		GList* child_it;
		child_collection = gtk_container_get_children ((GtkContainer*) self);
		for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
			GtkWidget* child;
			child = (GtkWidget*) child_it->data;
			{
				GtkWidget* _tmp1_;
				_tmp1_ = NULL;
				gnomenu_menu_item_set_gravity ((_tmp1_ = child, GNOMENU_IS_MENU_ITEM (_tmp1_) ? ((GnomenuMenuItem*) _tmp1_) : NULL), value);
			}
		}
		(child_collection == NULL) ? NULL : (child_collection = (g_list_free (child_collection), NULL));
	}
	gnomenu_menu_item_set_gravity (self->priv->_overflown_item, value);
	g_object_notify ((GObject *) self, "gravity");
}


gboolean gnomenu_menu_bar_get_overflown (GnomenuMenuBar* self) {
	g_return_val_if_fail (self != NULL, FALSE);
	switch (gtk_menu_bar_get_pack_direction ((GtkMenuBar*) self)) {
		case GTK_PACK_DIRECTION_TTB:
		case GTK_PACK_DIRECTION_BTT:
		{
			return ((GtkWidget*) self)->allocation.height < ((GtkWidget*) self)->requisition.height;
		}
		default:
		{
			return ((GtkWidget*) self)->allocation.width < ((GtkWidget*) self)->requisition.width;
		}
	}
}


static GnomenuItem* gnomenu_menu_bar_real_get_owner (GnomenuShell* base) {
	GnomenuMenuBar* self;
	self = (GnomenuMenuBar*) base;
	return NULL;
}


static gint gnomenu_menu_bar_real_get_length (GnomenuShell* base) {
	GnomenuMenuBar* self;
	self = (GnomenuMenuBar*) base;
	return gtk_menu_shell_length_without_truncated (self);
}


static void gnomenu_menu_bar_real_set_length (GnomenuShell* base, gint value) {
	GnomenuMenuBar* self;
	self = (GnomenuMenuBar*) base;
	gtk_menu_shell_truncate (self, value);
	g_object_notify ((GObject *) self, "length");
}


/*FIXME: this is not awared yet
  override set_child_property
  get_child_property,
  gonna be messy
install_child_property (
PROP_IMPORTANT,
new ParamSpecBoolean("important", 
"Imporant",
"Whether this item should not be overflown if possible",
false,
ParamFlags.READABLE | ParamFlags.WRITABLE)
);
*/
static GObject * gnomenu_menu_bar_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GnomenuMenuBarClass * klass;
	GObjectClass * parent_class;
	GnomenuMenuBar * self;
	klass = GNOMENU_MENU_BAR_CLASS (g_type_class_peek (GNOMENU_TYPE_MENU_BAR));
	parent_class = G_OBJECT_CLASS (g_type_class_peek_parent (klass));
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = GNOMENU_MENU_BAR (obj);
	{
		GnomenuBackground* _tmp0_;
		self->priv->disposed = FALSE;
		_tmp0_ = NULL;
		self->priv->_background = (_tmp0_ = gnomenu_background_new (), (self->priv->_background == NULL) ? NULL : (self->priv->_background = (gnomenu_background_unref (self->priv->_background), NULL)), _tmp0_);
		gnomenu_menu_bar_setup_overflown_item (self);
	}
	return obj;
}


static void gnomenu_menu_bar_class_init (GnomenuMenuBarClass * klass) {
	gnomenu_menu_bar_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GnomenuMenuBarPrivate));
	G_OBJECT_CLASS (klass)->dispose = gnomenu_menu_bar_real_dispose;
	GNOMENU_MENU_BAR_CLASS (klass)->emit_activate = gnomenu_menu_bar_real_emit_activate;
	GNOMENU_MENU_BAR_CLASS (klass)->emit_select = gnomenu_menu_bar_real_emit_select;
	GNOMENU_MENU_BAR_CLASS (klass)->emit_deselect = gnomenu_menu_bar_real_emit_deselect;
	GTK_WIDGET_CLASS (klass)->style_set = gnomenu_menu_bar_real_style_set;
	GTK_MENU_SHELL_CLASS (klass)->move_selected = gnomenu_menu_bar_real_move_selected;
	GTK_CONTAINER_CLASS (klass)->forall = gnomenu_menu_bar_real_forall;
	GTK_WIDGET_CLASS (klass)->realize = gnomenu_menu_bar_real_realize;
	GTK_WIDGET_CLASS (klass)->map = gnomenu_menu_bar_real_map;
	GTK_WIDGET_CLASS (klass)->size_allocate = gnomenu_menu_bar_real_size_allocate;
	GTK_WIDGET_CLASS (klass)->expose_event = gnomenu_menu_bar_real_expose_event;
	GTK_WIDGET_CLASS (klass)->focus_out_event = gnomenu_menu_bar_real_focus_out_event;
	GTK_WIDGET_CLASS (klass)->focus_in_event = gnomenu_menu_bar_real_focus_in_event;
	GTK_WIDGET_CLASS (klass)->size_request = gnomenu_menu_bar_real_size_request;
	GTK_MENU_SHELL_CLASS (klass)->insert = gnomenu_menu_bar_real_insert;
	G_OBJECT_CLASS (klass)->get_property = gnomenu_menu_bar_get_property;
	G_OBJECT_CLASS (klass)->set_property = gnomenu_menu_bar_set_property;
	G_OBJECT_CLASS (klass)->constructor = gnomenu_menu_bar_constructor;
	G_OBJECT_CLASS (klass)->finalize = gnomenu_menu_bar_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNOMENU_MENU_BAR_BACKGROUND, gnomenu_param_spec_background ("background", "background", "background", GNOMENU_TYPE_BACKGROUND, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNOMENU_MENU_BAR_GRAVITY, g_param_spec_enum ("gravity", "gravity", "gravity", GNOMENU_TYPE_GRAVITY, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNOMENU_MENU_BAR_OVERFLOWN, g_param_spec_boolean ("overflown", "overflown", "overflown", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_override_property (G_OBJECT_CLASS (klass), GNOMENU_MENU_BAR_OWNER, "owner");
	g_object_class_override_property (G_OBJECT_CLASS (klass), GNOMENU_MENU_BAR_LENGTH, "length");
	g_signal_new ("activate", GNOMENU_TYPE_MENU_BAR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GNOMENU_TYPE_MENU_ITEM);
	g_signal_new ("select", GNOMENU_TYPE_MENU_BAR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GNOMENU_TYPE_MENU_ITEM);
	g_signal_new ("deselect", GNOMENU_TYPE_MENU_BAR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GNOMENU_TYPE_MENU_ITEM);
	{
	}
}


static void gnomenu_menu_bar_gnomenu_shell_interface_init (GnomenuShellIface * iface) {
	gnomenu_menu_bar_gnomenu_shell_parent_iface = g_type_interface_peek_parent (iface);
	iface->get_item = gnomenu_menu_bar_real_get_item;
	iface->get_item_by_id = gnomenu_menu_bar_real_get_item_by_id;
	iface->get_item_position = gnomenu_menu_bar_real_get_item_position;
	iface->get_owner = gnomenu_menu_bar_real_get_owner;
	iface->get_length = gnomenu_menu_bar_real_get_length;
	iface->set_length = gnomenu_menu_bar_real_set_length;
}


static void gnomenu_menu_bar_instance_init (GnomenuMenuBar * self) {
	self->priv = GNOMENU_MENU_BAR_GET_PRIVATE (self);
	self->priv->_overflown_item = g_object_ref_sink (gnomenu_menu_item_new ());
}


static void gnomenu_menu_bar_finalize (GObject* obj) {
	GnomenuMenuBar * self;
	self = GNOMENU_MENU_BAR (obj);
	(self->priv->_background == NULL) ? NULL : (self->priv->_background = (gnomenu_background_unref (self->priv->_background), NULL));
	(self->priv->_overflown_item == NULL) ? NULL : (self->priv->_overflown_item = (g_object_unref (self->priv->_overflown_item), NULL));
	G_OBJECT_CLASS (gnomenu_menu_bar_parent_class)->finalize (obj);
}


GType gnomenu_menu_bar_get_type (void) {
	static GType gnomenu_menu_bar_type_id = 0;
	if (gnomenu_menu_bar_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (GnomenuMenuBarClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gnomenu_menu_bar_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GnomenuMenuBar), 0, (GInstanceInitFunc) gnomenu_menu_bar_instance_init, NULL };
		static const GInterfaceInfo gnomenu_shell_info = { (GInterfaceInitFunc) gnomenu_menu_bar_gnomenu_shell_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		gnomenu_menu_bar_type_id = g_type_register_static (GTK_TYPE_MENU_BAR, "GnomenuMenuBar", &g_define_type_info, 0);
		g_type_add_interface_static (gnomenu_menu_bar_type_id, GNOMENU_TYPE_SHELL, &gnomenu_shell_info);
	}
	return gnomenu_menu_bar_type_id;
}


static void gnomenu_menu_bar_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	GnomenuMenuBar * self;
	gpointer boxed;
	self = GNOMENU_MENU_BAR (object);
	switch (property_id) {
		case GNOMENU_MENU_BAR_BACKGROUND:
		gnomenu_value_set_background (value, gnomenu_menu_bar_get_background (self));
		break;
		case GNOMENU_MENU_BAR_GRAVITY:
		g_value_set_enum (value, gnomenu_menu_bar_get_gravity (self));
		break;
		case GNOMENU_MENU_BAR_OVERFLOWN:
		g_value_set_boolean (value, gnomenu_menu_bar_get_overflown (self));
		break;
		case GNOMENU_MENU_BAR_OWNER:
		g_value_set_object (value, gnomenu_shell_get_owner ((GnomenuShell*) self));
		break;
		case GNOMENU_MENU_BAR_LENGTH:
		g_value_set_int (value, gnomenu_shell_get_length ((GnomenuShell*) self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void gnomenu_menu_bar_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	GnomenuMenuBar * self;
	self = GNOMENU_MENU_BAR (object);
	switch (property_id) {
		case GNOMENU_MENU_BAR_BACKGROUND:
		gnomenu_menu_bar_set_background (self, gnomenu_value_get_background (value));
		break;
		case GNOMENU_MENU_BAR_GRAVITY:
		gnomenu_menu_bar_set_gravity (self, g_value_get_enum (value));
		break;
		case GNOMENU_MENU_BAR_LENGTH:
		gnomenu_shell_set_length ((GnomenuShell*) self, g_value_get_int (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}




